# Walmart data

This folder contains Walmart propiertary datasets. To request the data, please contact someone from Walmart-Chile. The contact number posted in their website is (+56 2) 2200 5000. Our point of contact was Carmen Roman, Walmart's head of corporate affairs in 2018. Her institutional email is: carmen.roman@walmart.com.

## Transaction-level data:

The transaction level data, once obtained, should be stored inside `00_files/01_source/01_walmart/Full/`. Files come in format `month_year.txt` and contain transaction level data from May 2015 to March 2018.

The variables in these datafiles are:
* date: date of the transaction
* trx_id: transaction unique identifier 
* store_id: store identifier
* bar_code: SKU of the product purchased
* rut_doc: masked consumer identifier
* sales_raw: transaction amount before discounts in Chilean pesos
* discount_amt: discount amount in Chilean pesos
* sales_final: final transaction amount in Chilean pesos
* quantity: quantities of the product purchased
* quant_weight: weight of the product purchased

## Complementary files:

There are complementary datasets shared by the Walmart-Chile team that should be stored in `00_files/01_source/01_walmart/`. The file names are:

* Clasificacion.xlsx
* direccion_georeferenciada.csv
* holding.xlsx
* Informacion Locales.xlsx
* locales y deptos.xlsx
* locales_comunas.dta
* locales_deptos.dta
* productList.txt
* Productos AltosEn deptos Panaderia Pasteleria Fiambreria y Deli.xlsx
* RptSabanaInformacionNutricional.xlsb
* TRAIT DE PRECIOS WALMARTCHILE.xlsx
* traits_raw.dta
* traits_raw.xlsx

## Access to the file

In case there are problems obtaining the files from Walmart, you can reach out to Nano Barahona (nanobk@berkeley.edy). Nano has access to a copy of all files stored in a secure server at Stanford University from which the files can be transfered upon request and provided explicit permission from Walmart-Chile so that the current agreement is not violated.
