*********************************************************************************************************
clear all
set more off
set scheme s1color

log using "99_logfiles/c02_importData.log", replace
global dta 	  "00_files/02_intermediate/01_panel"

********************************************************************************
**			KEEP ONLY INDIVIDUALS WHO BUY CEREALS
********************************************************************************

use "${dta}/02a_MasterConsumerPanelData1-40.dta", clear 
forv i = 1/40 {
preserve
tempfile temp`i'
keep if week=="`i'"
destring week, replace
foreach var in store_id sales_raw discount_amt sales_final quantity quant_weight  day week category {
destring `var' , replace
}
drop customer_id bar_code
compress
save `temp`i'', replace
restore
}
clear
forv i = 1/40 {
append using `temp`i''
}
keep if week <= 40
gen week8 = floor((week-1)/8)+1
keep if category==9369
tempfile tempfile_1_40
save `tempfile_1_40', replace
save "${dta}/temp/tempfile_1_40.dta", replace


use  using "${dta}/02b_MasterConsumerPanelData41-90", clear
forv i = 41/90 {
preserve
tempfile temp`i'
keep if week=="`i'"
destring week, replace
foreach var in store_id sales_raw discount_amt sales_final quantity quant_weight  day week category {
destring `var' , replace
}
drop customer_id bar_code
compress
save `temp`i'', replace
restore
}
clear
forv i = 41/88 {
append using `temp`i''
}
keep if week <= 88
gen week8 = floor((week-1)/8)+1
keep if category==9369
tempfile tempfile_41_88
save `tempfile_41_88', replace
save "${dta}/temp/tempfile_41_88.dta", replace


use using "${dta}/02c_MasterConsumerPanelData91-152", clear
forv i = 91/152 {
preserve
tempfile temp`i'
keep if week=="`i'"
destring week, replace
foreach var in store_id sales_raw discount_amt sales_final quantity quant_weight  day week category {
destring `var' , replace
}
drop customer_id bar_code
compress
save `temp`i'', replace
restore
}
clear
forv i = 89/152 {
append using `temp`i''
}
gen week8 = floor((week-1)/8)+1
keep if category==9369
tempfile tempfile_89_152
save `tempfile_89_152', replace
save "${dta}/temp/tempfile_89_152.dta", replace

use "${dta}/temp/tempfile_1_40.dta", clear
append using "${dta}/temp/tempfile_41_88.dta"
append using "${dta}/temp/tempfile_89_152.dta"


foreach var in store_id discount_amt sales_raw sales_final quantity quant_weight day week category rut_doc {
destring `var', replace
}


compress
 
save "${dta}/03_MasterConsumerPanelData_Cereals", replace 

cap rm "${dta}/temp/tempfile_1_40.dta"
cap rm "${dta}/temp/tempfile_41_88.dta"
cap rm "${dta}/temp/tempfile_89_152.dta"


