/*******************************************************************************
AUTHOR: Nano Barahona
CREATION: Nov-2022
ACTION: Creates cereal subcatories
SUMMARY: Takes finelines provided by walmart and aggregate it into 6 subcategories

********************************************************************************/



preserve
use "${Repo}/00_files/02_intermediate/02_nutrition/04_cereals_nutrition.dta", clear
merge 1:1 upc_id using "${Repo}/00_files/02_intermediate/02_nutrition/01_products_raw"
keep if _merge==3
gen new_fineline = ""
replace new_fineline = "AVENA" if (inlist(fineline,1155,2125,2150) | inlist(nutrition_id,"293841"))
replace new_fineline = "HOJUELAS" if inlist(fineline, 1165) | inlist(nutrition_id,"486384","293841","282821","492751","492753","492755","492757","492763","765041") ///
										| inlist(nutrition_id,"822108","765045","903783","825341","834055","903781","906175","887474","659387")
replace new_fineline = "AZUCARADO" if inlist(fineline,2025) | inlist(nutrition_id,"268222","295955","3239"."707185","707185","2759","298043","715184","298569","437421") ///
										| inlist(nutrition_id,"822106","822110","824652","770898","699608","699606","526568","898082","915382") ///
										| inlist(nutrition_id,"901216","824656","845912","848728","884046","884048","887450","905467","905854") ///
										| inlist(nutrition_id,"906177","901218") 
replace new_fineline = "CHOCOLATE" if inlist(fineline,2050) | inlist(nutrition_id,"279037","289853","289891","381128","743410","848532","910015","913552","760960") ///
										| inlist(nutrition_id,"764989","770902","707557","707553","915380","834057","905465","905852") ///
										| inlist(nutrition_id,"272768","665323") 
replace new_fineline = "DILATADO" if inlist(fineline,2075) | inlist(nutrition_id,"2739","2743","2747","297367","298551","486380","454600")
replace new_fineline = "GRANOLA" if inlist(fineline,4950,1195) | inlist(nutrition_id,"834065","765039","765043","826085","824654","700034","574598")
gen healthy = inlist(fineline,1185,1195,1205,1975,4950,1195,1155,2125,2150,6050)
replace healthy = 0 if inlist(nutrition_id,"298043")
replace healthy = 1 if inlist(nutrition_id,"282821","822110","824652","834055","834057","834065","848728","903783","915382")
duplicates drop nutrition_id name brand Lcal Lsug Lsod Lfat cal_post cal_pre sug_post sug_pre sod_post sod_pre fat_post fat_pre new_fineline healthy, force
keep nutrition_id new_fineline name brand Lcal Lsug Lsod Lfat cal_post cal_pre cal_late sug_post sug_pre sug_late sod_post sod_pre sod_late fat_post fat_pre fat_late healthy
cap tempfile temp
save `temp', replace
restore

merge n:1 nutrition_id using `temp'
