/*******************************************************************************
AUTHOR: Nano Barahona
CREATION: Feb-2019
ACTION: Cleans cereal's consumer panel for model estimation
SUMMARY:

********************************************************************************/

clear all
set more off

******************************************************************************** 
** SET PATH AND LOCALS
******************************************************************************** 

if c(username)=="Nano"   		  global Repo "/Users/Nano/Dropbox/Research/FoodLabels/food_labels/04_replication"
else 							  global Repo "."

******************************************************************************** 
** LOAD DATA AND MERGE TO STRUCTURAL ESTIMATION RESULTS
******************************************************************************** 

import delimited "${Repo}/00_files/04_estimates/02_supply/02_supplydata_prod.csv", clear 
tempfile file_prod
save `file_prod', replace


import delimited "${Repo}/00_files/04_estimates/02_supply/03_supplydata_costs.csv", clear 
tempfile file_micro
save `file_micro', replace


import delimited using "${Repo}/00_files/03_data/02_marketLevel_cereals_nobins.csv", clear

drop mu_cal mu_sug
merge n:1 product using `file_prod'
drop _merge

merge n:1 product market using `file_micro'
drop _merge

tempfile file_final
save `file_final', replace

use "${Repo}/00_files/03_data/02_marketLevel_cereals_nobins.dta", clear

ren mu_cal mu_cal_raw
ren mu_sug mu_sug_raw
ren market market_stata
merge 1:1 product market_stata using `file_final'
drop _merge


save "${Repo}/00_files/03_data/03_marketLevel_cereals_model.dta", replace


