function [G,dG,beta,delta,m,dm,e,V,ind_shares,ind_shares_inside] = a02_ComputeDistanceVector(otheta1,otheta2,otheta3,otheta4,otheta7,results)


global X Z market_product muw_fixed sigma_mu vp_ind vf_ind bins_weights_micro ind_dummies_micro market_bin f ns sigma_ratio wmatrix

if nargin >= 6
    disp(' ')
    disp('Calculating estmation results...');
end


theta1 = otheta1;
theta2 = otheta2;
theta3 = 1/(1+exp(-otheta3));
theta4 = [5*(2/pi)*atan(otheta4),sigma_ratio*5*(2/pi)*atan(otheta4)];
theta7 = otheta7;


muw = [extractData(market_product,muw_fixed(:,1)),extractData(market_product,muw_fixed(:,2))];
sigmamuw = [extractData(market_product,sigma_mu(:,1)),extractData(market_product,sigma_mu(:,2))];
muw = [muw(market_product,1),muw(market_product,2)];
sigmamuw = [sigmamuw(market_product,1),sigmamuw(market_product,2)];


[Ew,dEw] = a03_calculatePosteriors(theta4,muw,sigmamuw);

[delta,mu,~,ind_shares,ind_shares_inside,p_wide,Ecal_wide,Esug_wide] = a04_ComputeModelOutputs(theta1,theta2,theta3,theta7,Ew);

X2 = X(:,3:end);

beta = ((X2'*Z)*wmatrix*(Z'*X2)) \ ((X2'*Z)*wmatrix*(Z'*delta));

disp(' ')
disp('PARAMETERS:')
disp(['rho: ',num2str(theta3)])
disp(['mu: ',num2str(theta4)])

alpha_i = -exp(sum([theta1(1),theta1(2)].*ind_dummies_micro,2)-(theta2(1)*vp_ind(:,2)'));
phic_i  = -exp(sum([theta1(3),theta1(4)].*ind_dummies_micro,2)-(theta2(2)*vp_ind(:,3)'));
phis_i  = -exp(sum([theta1(5),theta1(6)].*ind_dummies_micro,2)-(theta2(3)*vp_ind(:,4)'));
disp(['alpha: ',num2str([mean(mean(alpha_i(ind_dummies_micro(:,1)==1,:),2)),mean(mean(alpha_i(ind_dummies_micro(:,2)==1,:),2))])])
disp(['phi_cal: ',num2str([mean(mean(phic_i(ind_dummies_micro(:,1)==1,:),2)),mean(mean(phic_i(ind_dummies_micro(:,2)==1,:),2))])])
disp(['phi_sug: ',num2str([mean(mean(phis_i(ind_dummies_micro(:,1)==1,:),2)),mean(mean(phis_i(ind_dummies_micro(:,2)==1,:),2))])])
disp(['theta1: ',num2str(theta1)])
disp(['stdtheta2: ',num2str([std(alpha_i(1,:)),std(phic_i(1,:)),std(phis_i(1,:))])])

disp(['theta2: ',num2str(theta2)])
disp(['theta7: ',num2str(theta7)])


market_tmp = market_bin;


f1_wide = expand(f(:,5),[1,ns]);
f2_wide = expand(f(:,2),[1,ns]);
f3_wide = expand(f(:,3),[1,ns]);
f4_wide = expand(f(:,1),[1,ns]);
f5_wide = expand(f(:,4),[1,ns]);

dEcal_wide = expand(-dEw(:,1),[1,ns]);
dEsug_wide = expand(-dEw(:,2),[1,ns]);

ddelta_dtheta1 = zeros(length(delta),length(theta1));
ddelta_dtheta2 = zeros(length(delta),length(theta2));
ddelta_dtheta3 = zeros(length(delta),length(theta3));
ddelta_dtheta4 = zeros(length(delta),length(theta4));
ddelta_dtheta7 = zeros(length(delta),length(theta7));

vp = vp_ind';
vf = vf_ind';


for m = 1:max(market_tmp)
    shares_m = ind_shares(market_tmp==m, :);
    shares_m_inside = ind_shares_inside(market_tmp==m, :);
    bins_weights_m = bins_weights_micro(market_tmp==m, :);
    u_m = delta(market_tmp==m, :) + mu(market_tmp==m, :);
    ds_ddelta_j = (1/(1-theta3))*(bins_weights_m.*shares_m)*(1-theta3*shares_m_inside'-(1-theta3)*shares_m').*(eye(length(shares_m(:,1)),length(shares_m(:,1))));
    ds_ddelta_k = -(1/(1-theta3))*(bins_weights_m.*shares_m)*(theta3*shares_m_inside'+(1-theta3)*shares_m').*(1-eye(length(shares_m(:,1)),length(shares_m(:,1))));
    ds_ddelta = (ds_ddelta_j+ds_ddelta_k);
    
    alpha_m = alpha_i(market_tmp==m, :);
    phic_m = phic_i(market_tmp==m, :);
    phis_m = phis_i(market_tmp==m, :);
    type_m = ind_dummies_micro(market_tmp==m,1);
    
    ds_dtheta1 = (1/(1-theta3))*[...
        sum(bins_weights_m.*shares_m.*(alpha_m.*type_m).*(p_wide(market_tmp==m,:)-sum(p_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*(alpha_m.*(1-type_m)).*(p_wide(market_tmp==m,:)-sum(p_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*(phic_m.*type_m).*(Ecal_wide(market_tmp==m,:)-sum(Ecal_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*(phic_m.*(1-type_m)).*(Ecal_wide(market_tmp==m,:)-sum(Ecal_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*(phis_m.*type_m).*(Esug_wide(market_tmp==m,:)-sum(Esug_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*(phis_m.*(1-type_m)).*(Esug_wide(market_tmp==m,:)-sum(Esug_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2)];
    
    ds_dtheta2 = (1/(1-theta3))*[...
        sum(bins_weights_m.*shares_m.*(-alpha_m.*vp(2,:)).*(p_wide(market_tmp==m,:)-sum(p_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*(-phic_m.*vp(3,:)).*(Ecal_wide(market_tmp==m,:)-sum(Ecal_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*(-phis_m.*vp(4,:)).*(Esug_wide(market_tmp==m,:)-sum(Esug_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2)];
    
    ds_dtheta4 = (1/(1-theta3))*[...
        sum(bins_weights_m.*shares_m.*phic_m.*(dEcal_wide(market_tmp==m,:)-sum(dEcal_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*phis_m.*(dEsug_wide(market_tmp==m,:)-sum(dEsug_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2)];
    
    ds_dtheta3 = (1/(1-theta3)^2)*sum(bins_weights_m.*shares_m.*(u_m-sum(u_m.*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)-((1-theta3)^2)*log(sum(exp(u_m/(1-theta3)),1)).*(1-shares_m./shares_m_inside)),2);

    ds_dtheta7 = (1/(1-theta3))*[...
        sum(bins_weights_m.*shares_m.*expand(vf(1,:),[length(shares_m(:,1)),1]).*(f1_wide(market_tmp==m,:)-sum(f1_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*expand(vf(2,:),[length(shares_m(:,1)),1]).*(f2_wide(market_tmp==m,:)-sum(f2_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*expand(vf(3,:),[length(shares_m(:,1)),1]).*(f3_wide(market_tmp==m,:)-sum(f3_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*expand(vf(4,:),[length(shares_m(:,1)),1]).*(f4_wide(market_tmp==m,:)-sum(f4_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2), ...
        sum(bins_weights_m.*shares_m.*expand(vf(5,:),[length(shares_m(:,1)),1]).*(f5_wide(market_tmp==m,:)-sum(f5_wide(market_tmp==m,:).*((theta3)*shares_m_inside+(1-theta3)*shares_m),1)),2)];
    
    ddelta_dtheta1(market_tmp==m, :) = -ds_ddelta\ds_dtheta1;
    ddelta_dtheta2(market_tmp==m, :) = -ds_ddelta\ds_dtheta2;
    ddelta_dtheta3(market_tmp==m, :) = -ds_ddelta\ds_dtheta3;
    ddelta_dtheta4(market_tmp==m, :) = -ds_ddelta\ds_dtheta4;
    ddelta_dtheta7(market_tmp==m, :) = -ds_ddelta\ds_dtheta7;
    
end

e = delta - X2*beta;

ddelta_dtheta = [ddelta_dtheta1, ddelta_dtheta2, ddelta_dtheta3, (ddelta_dtheta4(:,1)+sigma_ratio*ddelta_dtheta4(:,2)), ddelta_dtheta7];

de = (ddelta_dtheta)-X2*(((X2'*Z)*wmatrix*(Z'*X2)) \ ((X2'*Z)*wmatrix*(Z'*(ddelta_dtheta))));

g = repmat(e, [1, length(Z(1,:))]) .* Z;
Nobs = length(e);
m = mean(g)';
dm = Z'*de/Nobs;
W = wmatrix*(Nobs);


G = 1000*(m' * W * m);

dtheta1 = ones(size(otheta1));
dtheta2 = ones(size(otheta2));
dtheta3 = exp(-otheta3)./((1+exp(-otheta3)).^2);
dtheta4 = 5*2./(pi*(1+otheta4.^2));
dtheta7 = ones(size(theta7));
dG = 1000*(2*(m' * W * dm)).*[dtheta1,dtheta2,dtheta3,dtheta4,dtheta7];

display(['OBJECTIVE: ',num2str(G)])
display(['GRADIENT: ',num2str(dG)])

if nargin >= 6

A = dm;

Omega = zeros(size(W));
for i=1:Nobs
    Omega = Omega + g(i,:)'*g(i,:);
end
Omega = Omega/Nobs;

V = inv(A'*W*A)*(A'*W*Omega*W*A)*inv(A'*W*A)/Nobs;

else
V=NaN;
end

disp(['Time passed: ', num2str(toc/60), ' minutes.'])
display(' ')


end


