
function [Ew,dEw,beliefs,muw] = a03_calculatePosteriors(theta4,muw_fixed,sigma_mu)

global wbar post product product_bins exempted l individual_bins

numnut = 2;

mu_shift = theta4;
num_ind_bins = 1;
muw = muw_fixed - mu_shift;
individuals_bins_vec = individual_bins;

muw(muw<0) = 0;

post_vec = repmat(expand(post,[num_ind_bins,1]),[1,numnut]);
exempted_vec = repmat(expand(exempted,[num_ind_bins,1]),[1,numnut]);
sigma_vec = sigma_mu;
wbar_vec = repmat(wbar,[length(muw(:,1)),1]);
l_vec = expand(l,[num_ind_bins,1]);
product_vec = expand(product,[num_ind_bins,1]);

Phi1 = @(x) (normpdf(-x)./(normcdf(-x)));
Phi2 = @(x) normpdf(x)./(normcdf(x));
arg = (wbar_vec-muw)./sigma_vec;

Ew = muw + ((1-exempted_vec).*post_vec.*l_vec.*sigma_vec.*Phi1(arg)) - ((1-exempted_vec).*post_vec.*(1-l_vec).*sigma_vec.*Phi2(arg));
dEw = 1-((1-exempted_vec).*post_vec.*l_vec.*Phi1(arg).*(Phi1(arg)-arg))-((1-exempted_vec).*post_vec.*(1-l_vec).*Phi2(arg).*(Phi2(arg)+arg));


for i = 1:numnut
    muwnan = muw((isnan(Ew(:,i))|Ew(:,i)==Inf|Ew(:,i)==-Inf),i);
    wbarnan = wbar_vec((isnan(Ew(:,i))|Ew(:,i)==Inf|Ew(:,i)==-Inf),i);
    lnan = l_vec((isnan(Ew(:,i))|Ew(:,i)==Inf|Ew(:,i)==-Inf),i);
    postnan = post_vec((isnan(Ew(:,i))|Ew(:,i)==Inf|Ew(:,i)==-Inf),i);
    Ew((isnan(Ew(:,i))|Ew(:,i)==Inf|Ew(:,i)==-Inf),i) = muwnan.*((muwnan<wbarnan & lnan==0) | (muwnan>wbarnan & lnan==1) | postnan==0 ) + wbarnan.*(((muwnan>wbarnan & lnan==0) | (muwnan<wbarnan & lnan==1)) &  postnan==1 );
end

for i = 1:numnut
    lnan = l_vec((isnan(dEw(:,i))|dEw(:,i)==-Inf|dEw(:,i)==Inf),i);
    postnan = post_vec((isnan(dEw(:,i))|dEw(:,i)==-Inf|dEw(:,i)==Inf),i);
    muwnan = muw((isnan(dEw(:,i))|dEw(:,i)==-Inf|dEw(:,i)==Inf),i);
    wbarnan = wbar_vec((isnan(dEw(:,i))|dEw(:,i)==-Inf|dEw(:,i)==Inf),i);
    dEw((isnan(dEw(:,i))|dEw(:,i)==-Inf|dEw(:,i)==Inf),i) = 1-(((muwnan>wbarnan & lnan==0) | (muwnan<wbarnan & lnan==1)) &  postnan==1 );
end

dEw(muw<=0) = 0;
Ew(Ew<0) = 0;

beliefs = [extractData(product_bins(post_vec(:,1)==1),product_vec(post_vec(:,1)==1,1)),extractData(product_bins(post_vec(:,1)==1),individuals_bins_vec(post_vec(:,1)==1,1)),extractData(product_bins(post_vec(:,1)==1),muw(post_vec(:,1)==1,1)),extractData(product_bins(post_vec(:,1)==1),Ew(post_vec(:,1)==1,1)),extractData(product_bins(post_vec(:,1)==1),muw(post_vec(:,1)==1,2)),extractData(product_bins(post_vec(:,1)==1),Ew(post_vec(:,1)==1,2))];
    

end





