function [delta,u_mu,niter,ind_shares,ind_shares_inside,p_wide,Ecal_wide,Esug_wide] = a04_ComputeModelOutputs(theta1,theta2,theta3,theta7,Ew)

global X s s_g vp_ind vf_ind logitvar maxiters delta_tol f ns ind_dummies_micro


alpha_i = -exp(sum([theta1(1),theta1(2)].*ind_dummies_micro,2)-(theta2(1)*vp_ind(:,2)'));
phic_i  = -exp(sum([theta1(3),theta1(4)].*ind_dummies_micro,2)-(theta2(2)*vp_ind(:,3)'));
phis_i  = -exp(sum([theta1(5),theta1(6)].*ind_dummies_micro,2)-(theta2(3)*vp_ind(:,4)'));


p_wide = expand((X(:,1)+X(:,2)),[1,ns]);
Ecal_wide = expand(Ew(:,1),[1,ns]);
Esug_wide = expand(Ew(:,2),[1,ns]);
f1_wide = expand(f(:,5),[1,ns]);
f2_wide = expand(f(:,2),[1,ns]);
f3_wide = expand(f(:,3),[1,ns]);
f4_wide = expand(f(:,1),[1,ns]);
f5_wide = expand(f(:,4),[1,ns]);
u_mu = alpha_i.*p_wide ...
    + phic_i.*Ecal_wide ...
    + phis_i.*Esug_wide ...
    + (theta7(1)*vf_ind(:,1)').*f1_wide ...
    + (theta7(2)*vf_ind(:,2)').*f2_wide ...
    + (theta7(3)*vf_ind(:,3)').*f3_wide ...
    + (theta7(4)*vf_ind(:,4)').*f4_wide ...
    + (theta7(5)*vf_ind(:,5)').*f5_wide;




% DEMAND INVERSION

fun=@(x) (x + (1-theta3)*(log(s) - log(a06_ComputeMarketShare(x, exp(u_mu/(1-theta3)), theta3))));
delta0 = logitvar-theta3*log(s_g)-mean(u_mu,2);
[delta,niter,xchng]=fp_squarem(fun,delta0,'algorithm','squarem','max_iter',maxiters,'con_tol',delta_tol);
[~, ind_shares,ind_shares_inside] = a06_ComputeMarketShare(delta, exp(u_mu/(1-theta3)), theta3);
i = 1;
disp(' ')
display(['Inversion done in ', int2str(niter),' iterations. Tol: ' num2str(xchng)])
disp(['Time passed: ', num2str(toc/60), ' minutes.'])
while (niter==maxiters && i<10) || (max(isnan(delta))==1 && i<10)
    display(['ITER: ',int2str(i),' ',int2str(sum(isnan(delta))),' number of NaN'])
    delta(isnan(delta)) = logitvar(isnan(delta))-theta3*log(s_g(isnan(delta)));
    [delta,~] = a05_DeltaContraction(s,exp(u_mu/(1-theta3)),theta3,delta,maxiters,delta_tol);
    [delta,niter,xchng]=fp_squarem(fun,delta,'algorithm','squarem','max_iter',maxiters,'con_tol',delta_tol);
    [~, ind_shares,ind_shares_inside] = a06_ComputeMarketShare(delta, exp(u_mu/(1-theta3)), theta3);
    i=i+1;
    display(['Inversion done in ', int2str(niter),' iterations. Tol: ' num2str(xchng)])
    disp(['Time passed: ', num2str(toc/60), ' minutes.'])
end
if i==10
    display('WARNING: max number of iterations reached')
    delta(isnan(delta)) = logitvar(isnan(delta))-theta3*log(s_g(isnan(delta)));
end





end



