

function [median_elast,median_diversion] = a07_calculateElast(s_wide,s_g_wide,p_wide,weights_wide_norm,alpha_wide,rho_wide,market_wide,market_array)

global J market

M = max(market);
weighted_shares = s_wide.*weights_wide_norm;
weighted_price = p_wide.*weights_wide_norm;
s_m_wide = cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),weighted_shares(:,x)),1:J+1,'un',0));
p_m_wide = cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),weighted_price(:,x)),1:J+1,'un',0));

% we calculate ds_j/dp_k where j are rows
e_JJ = [eye(J);zeros(1,J)];
ds_k = (alpha_wide(:,1:J).*weights_wide_norm(:,1:J).*s_wide(:,1:J)./(1-rho_wide(:,1:J)));
ds_j = [(rho_wide(:,1:J).*s_g_wide(:,1:J) + (1-rho_wide(:,1:J)).*s_wide(:,1:J)),(1-rho_wide(:,J+1)).*s_wide(:,J+1)]';
ds_k(isnan(ds_k))=0;
ds_j(isnan(ds_j))=0;
market_choice = market_wide(:,1);
eta_m = zeros(J+1,J,M);
D_m = zeros(J+1,J,M);
ds_dp_m = zeros(J+1,J,M);

for m=market_array'

ds_dp_m(:,:,m) = ((ds_j(:,market_choice==m)*ds_k((market_choice==m),:).*(1-e_JJ)) + -((1-ds_j(:,market_choice==m))*ds_k((market_choice==m),:).*e_JJ));
eta_m(:,:,m) = ds_dp_m(:,:,m).*(repmat(p_m_wide(m,1:J),[J+1,1])./repmat(s_m_wide(m,1:J+1)',[1,J]));
D_m(:,:,m) = -ds_dp_m(:,:,m)./(repmat(diag(ds_dp_m(:,:,m))',[J+1,1]));

end

eta_m(eta_m==0)=NaN;
D_m(D_m==0)=NaN;
median_elast = nanmedian(eta_m,3);
median_diversion = nanmedian(D_m,3);


end


    

