
%% We create all exogenous variables

disp(' ')

% We do everything on a wide panel structure

% firm and market id
product_wide = [repmat(extractData(data_product, data_product)',[M*N,1]),zeros(M*N,1)]; 
market_wide = repmat(expand(extractData(data_market_bin, data_market),[N/2,1]),[1,J+1]);
market_bin_wide = repmat(expand(extractData(data_market_bin, data_market_bin),[N/2,1]),[1,J+1]);
week_wide = repmat(expand(extractData(data_market_bin, data_week),[N/2,1]),[1,J+1]);
store_wide = repmat(expand(extractData(data_market_bin, data_store),[N/2,1]),[1,J+1]);
type_wide = repmat(expand(extractData(data_market_bin, data_individual_type),[N/2,1]),[1,J+1]);
firm_wide = [repmat(extractData(data_product, data_brand)',[M*N,1]),zeros(M*N,1)];
holding_wide = [repmat(extractData(data_product, data_holding)',[M*N,1]),zeros(M*N,1)];

% market size by bins
market_size_bins_wide = repmat(expand(extractData(data_market_bin, data_market_size_bin),[N/2,1]),[1,J+1]);
portion_size_bins_wide = repmat(expand(extractData(data_market_bin, data_portion_size_bin),[N/2,1]),[1,J+1]);
weights_wide = (market_size_bins_wide.*portion_size_bins_wide)./repmat(2*expand(extractData(extractData(data_market_bin, data_market), extractData(data_market_bin, data_market_size_bin.*data_portion_size_bin)),[N,1]),[1,J+1])/(N/2);

% demand characteristics
xi_j_wide = [repmat([expand(xi_j_hat(:,1)',[N/2,1]);expand(xi_j_hat(:,2)',[N/2,1])],[M,1]),zeros(N*M,1)];
temp = [xi_t_hat(:,1);xi_t_hat(:,2)];
xi_t_wide = [repmat(expand(extractData(data_market_bin,temp(data_week_bin)),[N/2,1]),[1,J]),zeros(N*M,1)];
temp = [xi_s_hat(:,1);xi_s_hat(:,2)];
xi_s_wide = [repmat(expand(extractData(data_market_bin,temp(data_store_bin)),[N/2,1]),[1,J]),zeros(N*M,1)];
xi_wide = fillPanel_sup(xi_hat,-Inf);
fineline_wide = [repmat(extractData(data_product, data_fineline)',[N*M,1]),zeros(N*M,1)];  
healthy_wide = [repmat(extractData(data_product, data_healthy)',[N*M,1]),zeros(N*M,1)];  
exempted_wide = [repmat(extractData(data_product, data_exempted)',[N*M,1]),zeros(N*M,1)];  

% supply characteristics
nu_cal_wide = [repmat(extractData(data_product, data_cal_pre)',[N*M,1]),zeros(N*M,1)];
nu_sug_wide = [repmat(extractData(data_product, data_sug_pre)',[N*M,1]),zeros(N*M,1)];

cal_late_wide = [repmat(extractData(data_product, data_cal_late)',[N*M,1]),zeros(N*M,1)];
sug_late_wide = [repmat(extractData(data_product, data_sug_late)',[N*M,1]),zeros(N*M,1)];

% priors and policy
temp = extractData(data_product_bin, muw_hat(:,1));
mu_cal_wide = [repmat([expand(temp(1:J)',[N/2,1]);expand(temp(J+1:2*J)',[N/2,1])],[M,1]),zeros(N*M,1)];
temp = extractData(data_product_bin, muw_hat(:,2));
mu_sug_wide = [repmat([expand(temp(1:J)',[N/2,1]);expand(temp(J+1:2*J)',[N/2,1])],[M,1]),zeros(N*M,1)];
temp = extractData(data_product_bin, sigma_mu_hat(:,1));
sigmamu_cal_wide = [repmat([expand(temp(1:J)',[N/2,1]);expand(temp(J+1:2*J)',[N/2,1])],[M,1]),zeros(N*M,1)];
temp = extractData(data_product_bin, sigma_mu_hat(:,2));
sigmamu_sug_wide = [repmat([expand(temp(1:J)',[N/2,1]);expand(temp(J+1:2*J)',[N/2,1])],[M,1]),zeros(N*M,1)];
post_wide = repmat(expand(extractData(data_market_bin, data_post),[N/2,1]),[1,J+1]);

% beliefs shifters
Elab_cal_wide = [sigmamu_cal_wide(:,1:J).*((normpdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))./(1-normcdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))))),zeros(N*M,1)];
Enolab_cal_wide = [-sigmamu_cal_wide(:,1:J).*((normpdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))./(normcdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))))),zeros(N*M,1)];
Elab_cal_wide(Elab_cal_wide==Inf|isnan(Elab_cal_wide)) = wbar(1)*ones(length(mu_cal_wide(Elab_cal_wide==Inf|isnan(Elab_cal_wide))),1)-mu_cal_wide(Elab_cal_wide==Inf|isnan(Elab_cal_wide));
Enolab_cal_wide(Enolab_cal_wide==-Inf|isnan(Enolab_cal_wide)) = wbar(1)*ones(length(mu_cal_wide(Enolab_cal_wide==-Inf|isnan(Enolab_cal_wide))),1)-mu_cal_wide(Enolab_cal_wide==-Inf|isnan(Enolab_cal_wide));

Elab_sug_wide = [sigmamu_sug_wide(:,1:J).*((normpdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))./(1-normcdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))))),zeros(N*M,1)];
Enolab_sug_wide = [-sigmamu_sug_wide(:,1:J).*((normpdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))./(normcdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))))),zeros(N*M,1)];
Elab_sug_wide(Elab_sug_wide==Inf|isnan(Elab_sug_wide)) = wbar(2)*ones(length(mu_sug_wide(Elab_sug_wide==Inf|isnan(Elab_sug_wide))),1)-mu_sug_wide(Elab_sug_wide==Inf|isnan(Elab_sug_wide));
Enolab_sug_wide(Enolab_sug_wide==-Inf|isnan(Enolab_sug_wide)) = wbar(2)*ones(length(mu_sug_wide(Enolab_sug_wide==-Inf|isnan(Enolab_sug_wide))),1)-mu_sug_wide(Enolab_sug_wide==-Inf|isnan(Enolab_sug_wide));

Elab_cal_late_wide = [sigmamu_cal_wide(:,1:J).*((normpdf((wbar2(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))./(1-normcdf((wbar2(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))))),zeros(N*M,1)];
Enolab_cal_late_wide = [-sigmamu_cal_wide(:,1:J).*((normpdf((wbar2(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))./(normcdf((wbar2(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))))),zeros(N*M,1)];
Elab_cal_late_wide(Elab_cal_late_wide==Inf|isnan(Elab_cal_late_wide)) = wbar2(1)*ones(length(mu_cal_wide(Elab_cal_late_wide==Inf|isnan(Elab_cal_late_wide))),1)-mu_cal_wide(Elab_cal_late_wide==Inf|isnan(Elab_cal_late_wide));
Enolab_cal_late_wide(Enolab_cal_late_wide==-Inf|isnan(Enolab_cal_late_wide)) = wbar2(1)*ones(length(mu_cal_wide(Enolab_cal_late_wide==-Inf|isnan(Enolab_cal_late_wide))),1)-mu_cal_wide(Enolab_cal_late_wide==-Inf|isnan(Enolab_cal_late_wide));

Elab_sug_late_wide = [sigmamu_sug_wide(:,1:J).*((normpdf((wbar2(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))./(1-normcdf((wbar2(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))))),zeros(N*M,1)];
Enolab_sug_late_wide = [-sigmamu_sug_wide(:,1:J).*((normpdf((wbar2(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))./(normcdf((wbar2(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))))),zeros(N*M,1)];
Elab_sug_late_wide(Elab_sug_late_wide==Inf|isnan(Elab_sug_late_wide)) = wbar2(2)*ones(length(mu_sug_wide(Elab_sug_late_wide==Inf|isnan(Elab_sug_late_wide))),1)-mu_sug_wide(Elab_sug_late_wide==Inf|isnan(Elab_sug_late_wide));
Enolab_sug_late_wide(Enolab_sug_late_wide==-Inf|isnan(Enolab_sug_late_wide)) = wbar2(2)*ones(length(mu_sug_wide(Enolab_sug_late_wide==-Inf|isnan(Enolab_sug_late_wide))),1)-mu_sug_wide(Enolab_sug_late_wide==-Inf|isnan(Enolab_sug_late_wide));


% endogenous variables
p_wide = fillPanel_sup(data_p,NaN);
p_wide = expand(cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),p_wide(:,x),[],@(x)mean(x,'omitnan')),1:J+1,'un',0)),[N,1]);
p_wide(isnan(p_wide))=Inf;
s_wide = fillPanel_sup(data_s,0);
s_g_wide = fillPanel_sup(data_s_g,0);
l_cal_wide = fillPanel_sup(data_l_cal,0);
l_sug_wide = fillPanel_sup(data_l_sug,0);

% We reshape for a long panel structure
xi_j = reshape(xi_j_wide(:,1:J)',[J*M*N,1]);
xi_t = reshape(xi_t_wide(:,1:J)',[J*M*N,1]);
xi_s = reshape(xi_s_wide(:,1:J)',[J*M*N,1]);
xi = reshape(xi_wide(:,1:J)',[J*M*N,1]);
nu_cal = reshape(nu_cal_wide(:,1:J)',[J*M*N,1]);
nu_sug = reshape(nu_sug_wide(:,1:J)',[J*M*N,1]);
mu_cal = reshape(mu_cal_wide(:,1:J)',[J*M*N,1]);
mu_sug = reshape(mu_sug_wide(:,1:J)',[J*M*N,1]);
cal_late = reshape(cal_late_wide(:,1:J)',[J*M*N,1]);
sug_late = reshape(sug_late_wide(:,1:J)',[J*M*N,1]);
post = reshape(post_wide(:,1:J)',[J*M*N,1]);
Elab_cal = reshape(Elab_cal_wide(:,1:J)',[J*M*N,1]);
Enolab_cal = reshape(Enolab_cal_wide(:,1:J)',[J*M*N,1]);
Elab_sug = reshape(Elab_sug_wide(:,1:J)',[J*M*N,1]);
Enolab_sug = reshape(Enolab_sug_wide(:,1:J)',[J*M*N,1]);
Elab_cal_late = reshape(Elab_cal_late_wide(:,1:J)',[J*M*N,1]);
Enolab_cal_late = reshape(Enolab_cal_late_wide(:,1:J)',[J*M*N,1]);
Elab_sug_late = reshape(Elab_sug_late_wide(:,1:J)',[J*M*N,1]);
Enolab_sug_late = reshape(Enolab_sug_late_wide(:,1:J)',[J*M*N,1]);
product = reshape(product_wide(:,1:J)',[J*M*N,1]);
fineline = reshape(fineline_wide(:,1:J)',[J*M*N,1]);
fine = cell(F,1);
for f=1:F
    fine{f} = (fineline==f);
end
healthy = reshape(healthy_wide(:,1:J)',[J*M*N,1]);
firm = reshape(firm_wide(:,1:J)',[J*M*N,1]);
market = reshape(market_wide(:,1:J)',[J*M*N,1]);
market_bin = reshape(market_bin_wide(:,1:J)',[J*M*N,1]);
week = reshape(week_wide(:,1:J)',[J*M*N,1]);
store = reshape(store_wide(:,1:J)',[J*M*N,1]);
exempted = reshape(exempted_wide(:,1:J)',[J*M*N,1]);
p = reshape(p_wide(:,1:J)',[J*M*N,1]);
s = reshape(s_wide(:,1:J)',[J*M*N,1]);
s_g = reshape(s_g_wide(:,1:J)',[J*M*N,1]);
l_cal = reshape(l_cal_wide(:,1:J)',[J*M*N,1]);
l_sug = reshape(l_sug_wide(:,1:J)',[J*M*N,1]);
market_size_bins = reshape(market_size_bins_wide(:,1:J)',[J*M*N,1]);
portion_size_bins = reshape(portion_size_bins_wide(:,1:J)',[J*M*N,1]);
weights = reshape(weights_wide(:,1:J)',[J*M*N,1]);

% parameters
alpha_wide = exp(repmat(expand(alpha',[N/2,1])-repmat(Sigma(1)*vp_ind(:,2),[2,1]),[M,J+1]));
rho_wide = repmat(rho,[M*N,J+1]);
phi_cal_wide = exp(repmat(expand(phi_cal',[N/2,1])-repmat(Sigma(2)*vp_ind(:,3),[2,1]),[M,J+1]));
phi_sug_wide = exp(repmat(expand(phi_sug',[N/2,1])-repmat(Sigma(3)*vp_ind(:,4),[2,1]),[M,J+1]));
beta0_wide = repmat(expand(beta0',[N/2,1]),[M,J+1]);
beta_fine_wide = zeros(N*M,J+1);
fine_order = [5,2,3,1,4];
for f=1:F
    beta_fine_wide = beta_fine_wide + (fineline_wide==fine_order(f)).*repmat(repmat(Sigma(f+3)*vf_ind(:,f),[2,1]),[M,J+1]);
end




