
% Recover marginal cost and collapse variables to product level

disp(' ')

p(p==-Inf)=Inf;
p_wide(p_wide==-Inf)=Inf;
s(s==-Inf)=0;
l_cal(l_cal==-Inf)=0;
l_sug(l_sug==-Inf)=0;

E_cal = mu_cal + (post.*l_cal.*(1-exempted)).*Elab_cal + (post.*(1-l_cal).*(1-exempted)).*Enolab_cal;
E_cal(E_cal<0)=0;
E_cal_wide = [reshape(E_cal,[J,N*M])',zeros(N*M,1)];
E_sug = mu_sug + (post.*l_sug.*(1-exempted)).*Elab_sug + (post.*(1-l_sug).*(1-exempted)).*Enolab_sug;
E_sug(E_sug<0)=0;
E_sug_wide = [reshape(E_sug,[J,N*M])',zeros(N*M,1)];

[s_wide,s_g_wide] = a04_calculateShares(p_wide,E_cal_wide,E_sug_wide);
s = reshape(s_wide(:,1:J)',[J*N*M,1]);

[markup] = a05_calculateMarkup(s_wide,s_g_wide);
c = p-markup;

profit_sim = (p-c).*s.*market_size_bins.*portion_size_bins/(N/2);
profit_sim(isnan(profit_sim)) = 0;

c_bin = accumarray(findgroups(market_bin,product),c,[],@mean);
s_bin = accumarray(findgroups(market_bin,product),s,[],@mean);
week_bin = accumarray(findgroups(market_bin,product),week,[],@mean);
p_bin = accumarray(findgroups(market_bin,product),p,[],@mean);

exempted_prod = extractData(data_product,data_exempted);
post_prod = extractData(data_product,data_post);
l_cal_pre_prod = accumarray(data_product,data_cal_pre>wbar(1)*100,[],@max).*(1-exempted_prod);
l_sug_pre_prod = accumarray(data_product,data_sug_pre>wbar(2)*10,[],@max).*(1-exempted_prod);
l_cal_post_prod = accumarray(data_product,data_l_cal,[],@max);
l_sug_post_prod = accumarray(data_product,data_l_sug,[],@max);
bunching_cal_prod = (l_cal_pre_prod==1).*(l_cal_post_prod==0).*(1-exempted_prod);
bunching_sug_prod = (l_sug_pre_prod==1).*(l_sug_post_prod==0).*(1-exempted_prod);
cal_pre_prod = extractData(data_product,data_cal_pre/100);
sug_pre_prod = extractData(data_product,data_sug_pre/10);
cal_late_prod = extractData(data_product,data_cal_late/100);
sug_late_prod = extractData(data_product,data_sug_late/10);
cal_post_prod = extractData(data_product(data_post==1),data_cal(data_post==1)/100);
sug_post_prod = extractData(data_product(data_post==1),data_sug(data_post==1)/10);
mu_cal_prod = extractData(data_product,muw_hat(:,1));
mu_sug_prod = extractData(data_product,muw_hat(:,2));
fineline_prod = extractData(data_product,data_fineline);
c_prod = extractData(data_product,c_bin(s_bin>0));
firm_prod = extractData(data_product,data_brand);
mu_cal_post_prod = extractData(data_product(data_week>6),Ew_hat(data_week>6,1));
mu_sug_post_prod = extractData(data_product(data_week>6),Ew_hat(data_week>6,2));
bunching_cal_late_prod = (cal_pre_prod>2.75).*(cal_late_prod<=2.75).*(1-exempted_prod);
bunching_sug_late_prod = (sug_pre_prod>1).*(sug_late_prod<=1).*(1-exempted_prod);
ing_prod = [extractData(data_product,data_ingr(:,1)),extractData(data_product,data_ingr(:,2)),extractData(data_product,data_ingr(:,3))];

no_bunching_cal_prod = (l_cal_pre_prod==1).*(l_cal_post_prod==1).*(1-exempted_prod);
no_bunching_sug_prod = (l_sug_pre_prod==1).*(l_sug_post_prod==1).*(1-exempted_prod);

data_c = c_bin(s_bin>0);

data_xi_j = dummyvar(data_product);
data_xi_pre_j = data_xi_j.*repmat((1-data_post),[1,J]);
temp = [];
for i=1:J
temp = [temp,ceil(extractData(data_product,data_xi_pre_j(:,i)))];
end
both_periods_prod = sum(temp,2);


cost_week = zeros(J,max(week));
price_week = zeros(J,max(week));

for k=1:max(week)
    cost_week(:,k) = extractData(data_product(data_week==k),c_bin(s_bin>0&week_bin==k));
    price_week(:,k) = extractData(data_product(data_week==k),p_bin(s_bin>0&week_bin==k));
end

extracost_perweek = {zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week))};
fval_perweek = {zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week))};

if isfile([path,'00_files/04_estimates/02_supply/temp/ind_cost_curve.mat'])
    load([path,'00_files/04_estimates/02_supply/temp/ind_cost_curve']) 
end

extracost_perweek = {max(extracost_perweek{1},[],2),max(extracost_perweek{2},[],2),max(extracost_perweek{3},[],2),max(extracost_perweek{4},[],2),max(extracost_perweek{5},[],2)};
fval_perweek = [max(fval_perweek{1},[],2),max(fval_perweek{2},[],2),max(fval_perweek{3},[],2),max(fval_perweek{4},[],2),max(fval_perweek{5},[],2)];




