
global shift_bunching_cal shift_bunching_cal_last1 shift_bunching_cal_last2 shift_bunching_sug min_delta_cost max_delta_cost bunched not_bunched J

disp(' ')

max_delta_cost = Inf*ones(J,6);

bunched = [(l_cal_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 0),...
    (l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 0),...
    (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 0),...
    (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 1),...
    (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 0),...
    zeros(J,1)];

not_bunched = [((l_cal_pre_prod == 1 & l_sug_pre_prod == 0 & l_cal_post_prod == 1 & l_sug_post_prod == 0)|(l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 0)),...
    (l_cal_pre_prod == 0 & l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 1),...
    (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 1),...
    (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 1),...
    (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 1),...
    (1-exempted_prod).*ones(J,1)];

% bunching from 10 to 00
max_delta_cost(:,1) = -(l_cal_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 0).*extracost_perweek{3} + (l_cal_pre_prod ~= 1 | l_cal_post_prod ~= 0 | l_sug_post_prod ~= 0)*100;
% bunching from 01 to 00
max_delta_cost(:,2) = -(l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 0).*extracost_perweek{2} + (l_sug_pre_prod ~= 1 | l_cal_post_prod ~= 0 | l_sug_post_prod ~= 0)*100;
% bunching from 11 to 10
max_delta_cost(:,3) = -(l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 0).*extracost_perweek{4} + (l_cal_pre_prod ~= 1 | l_sug_pre_prod ~= 1 | l_cal_post_prod ~= 1 | l_sug_post_prod ~= 0)*100;
% bunching from 11 to 01
max_delta_cost(:,4) = -(l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 1).*extracost_perweek{4} + (l_cal_pre_prod ~= 1 | l_sug_pre_prod ~= 1 | l_cal_post_prod ~= 0 | l_sug_post_prod ~= 1)*100;
% bunching from 11 to 00
max_delta_cost(:,5) = -(l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 0).*extracost_perweek{4} + (l_cal_pre_prod ~= 1 | l_sug_pre_prod ~= 1 | l_cal_post_prod ~= 0 | l_sug_post_prod ~= 0)*100;
% bunching to last stage
max_delta_cost(:,6) = 100;

max_delta_cost(max_delta_cost==100) = Inf;

min_delta_cost = Inf*ones(J,6);

% not bunching from 10 to 00
min_delta_cost(:,1) = ((l_cal_pre_prod == 1 & l_sug_pre_prod == 0 & l_cal_post_prod == 1 & l_sug_post_prod == 0)|(l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 0)).*extracost_perweek{1};
% not bunching from 01 to 00
min_delta_cost(:,2) = (l_cal_pre_prod == 0 & l_sug_pre_prod == 1 & l_cal_post_prod == 0 & l_sug_post_prod == 1).*extracost_perweek{1};
% not bunching from 11 to 10
min_delta_cost(:,3) = (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 1).*extracost_perweek{3};
% not bunching from 11 to 01
min_delta_cost(:,4) = (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 1).*extracost_perweek{2};
% not bunching from 11 to 00
min_delta_cost(:,5) = (l_cal_pre_prod == 1 & l_sug_pre_prod == 1 & l_cal_post_prod == 1 & l_sug_post_prod == 1).*extracost_perweek{1};
% not bunching last stage
min_delta_cost(:,6) = extracost_perweek{5};

shift_bunching_cal = (cal_pre_prod-wbar(1));
shift_bunching_cal_last1 = max(cal_pre_prod-cal_post_prod,0);
shift_bunching_cal_last2 = (cal_pre_prod-2.75);
shift_bunching_sug =  (sug_pre_prod-wbar(2));


%% ESTIMATION

size = extractData(data_product, data_s.*data_market_size.*data_p);
size(isnan(size))=0;
size = J*size/sum(size);


GMM = @(x) a07_GMM(x,cal_pre_prod,sug_pre_prod);

x0 = [-2.35,1.87,-1.83,1.14,1.55];
%x0 = [-2.34924732808426,1.87358437451582,-1.83228885658287,1.14253988282040,1.54641459704562];

[param] = fminunc(GMM,x0,opts);
[G,dG,V] = GMM(param);
sd_param = sqrt(diag(V));
stars_param = (abs(param./sd_param)>1.64)+(abs(param./sd_param)>1.96)+(abs(param./sd_param)>2.58);


[bunched_cal,bunched_sug,not_bunched_cal,not_bunched_sug,bunched_cal_prob,bunched_sug_prob,bunched_cal_late_prob,delta_cost,E_lambda_prod,E_Lambda_prod] = a08_predictProb(param,v_sim,sug_pre_prod);



