
function [L,dL,V] = a11_MLE_log_analytic_Xs_gmm(x0,cal_pre_prod,sug_pre_prod)

global shift_bunching_cal shift_bunching_cal_last1 shift_bunching_cal_last2 shift_bunching_sug min_delta_cost max_delta_cost bunched not_bunched J size 

rng(2019);

% analytical solution
bunch_col1 = normcdf((log(max((max_delta_cost(:,1)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2));
bunch_col2 = normcdf((log(max((max_delta_cost(:,2)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4));
bunch_col3 = normcdf((log(max((max_delta_cost(:,3)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4));
bunch_col4 = normcdf((log(max((max_delta_cost(:,4)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2));
bunch_col5 = bunch_col1+bunch_col2-bunch_col1.*bunch_col2;
bunch_col6 = normcdf((log(max((max_delta_cost(:,6)./(shift_bunching_cal_last2.^2-shift_bunching_cal_last1.^2)),0))-x0(1))/x0(2));

not_bunch_col1 = 1-normcdf((log(max((min_delta_cost(:,1)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2));
not_bunch_col2 = 1-normcdf((log(max((min_delta_cost(:,2)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4));
not_bunch_col3 = 1-normcdf((log(max((min_delta_cost(:,3)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4));
not_bunch_col4 = 1-normcdf((log(max((min_delta_cost(:,4)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2));
not_bunch_col5 = not_bunch_col1+not_bunch_col2-not_bunch_col1.*not_bunch_col2;
not_bunch_col6 = 1-normcdf((log(max((min_delta_cost(:,6)./(shift_bunching_cal_last2.^2-shift_bunching_cal_last1.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2));

prob_bunch_anlytc  = [bunch_col1,bunch_col2,bunch_col3,bunch_col4,bunch_col5,bunch_col6];
prob_not_bunch_anlytc  = [not_bunch_col1,not_bunch_col2,not_bunch_col3,not_bunch_col4,not_bunch_col5,not_bunch_col6];

temp = prob_bunch_anlytc.*bunched;
temp_no = (1-prob_not_bunch_anlytc).*not_bunched;
bunched_sug_prob = max(temp(:,2),temp(:,3)) + max(temp_no(:,2),temp_no(:,3));
bunched_cal_prob = max(temp(:,1),temp(:,4)) + max(temp_no(:,1),temp_no(:,4));

bunched_sug = max(max(bunched(:,2),bunched(:,3)),bunched(:,5));
bunched_cal = max(max(bunched(:,1),bunched(:,4)),bunched(:,5));

Gi = [(size.*(bunched_cal-bunched_cal_prob)), ...
    (size.*(bunched_sug-bunched_sug_prob)), ...
    (size.*(bunched_cal-bunched_cal_prob).*cal_pre_prod), ...
    (size.*(bunched_sug-bunched_sug_prob).*sug_pre_prod), ... 
    (size.*(bunched_cal-bunched_cal_prob).*sug_pre_prod)];

% G = [sum(size.*(bunched_cal-bunched_cal_prob)); ...
%     sum(size.*(bunched_sug-bunched_sug_prob)); ...
%     sum(size.*(bunched_cal-bunched_cal_prob).*cal_pre_prod); ...
%     sum(size.*(bunched_sug-bunched_sug_prob).*sug_pre_prod); ... 
%     sum(size.*(bunched_cal-bunched_cal_prob).*sug_pre_prod)];

G = sum(Gi)';

L = G'*G;

d_bunch_col1 = repmat(normpdf((log(max((max_delta_cost(:,1)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2)),[1,5]).*[-ones(J,1)/x0(2),-(log(max((max_delta_cost(:,1)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/(x0(2))^2,zeros(J,1),zeros(J,1),-sug_pre_prod./x0(4)];
d_bunch_col1(isnan(d_bunch_col1)) = 0;
d_bunch_col2 = repmat(normpdf((log(max((max_delta_cost(:,2)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4)),[1,5]).*[zeros(J,1),zeros(J,1),-ones(J,1)/x0(4),-(log(max((max_delta_cost(:,2)./(shift_bunching_sug.^2)),0))-x0(3))/(x0(4))^2,zeros(J,1)];
d_bunch_col2(isnan(d_bunch_col2)) = 0;
d_bunch_col3 = repmat(normpdf((log(max((max_delta_cost(:,3)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4)),[1,5]).*[zeros(J,1),zeros(J,1),-ones(J,1)/x0(4),-(log(max((max_delta_cost(:,3)./(shift_bunching_sug.^2)),0))-x0(3))/(x0(4))^2,zeros(J,1)];
d_bunch_col3(isnan(d_bunch_col3)) = 0;
d_bunch_col4 = repmat(normpdf((log(max((max_delta_cost(:,4)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2)),[1,5]).*[-ones(J,1)/x0(2),-(log(max((max_delta_cost(:,4)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/(x0(2))^2,zeros(J,1),zeros(J,1),-sug_pre_prod./x0(4)];
d_bunch_col4(isnan(d_bunch_col4)) = 0;

d_not_bunch_col1 = repmat(normpdf((log(max((min_delta_cost(:,1)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2)),[1,5]).*[-ones(J,1)/x0(2),-(log(max((min_delta_cost(:,1)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/(x0(2))^2,zeros(J,1),zeros(J,1),-sug_pre_prod./x0(4)];
d_not_bunch_col1(isnan(d_not_bunch_col1)) = 0;
d_not_bunch_col2 = repmat(normpdf((log(max((min_delta_cost(:,2)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4)),[1,5]).*[zeros(J,1),zeros(J,1),-ones(J,1)/x0(4),-(log(max((min_delta_cost(:,2)./(shift_bunching_sug.^2)),0))-x0(3))/(x0(4))^2,zeros(J,1)];
d_not_bunch_col2(isnan(d_not_bunch_col2)) = 0;
d_not_bunch_col3 = repmat(normpdf((log(max((min_delta_cost(:,3)./(shift_bunching_sug.^2)),0))-x0(3))/x0(4)),[1,5]).*[zeros(J,1),zeros(J,1),-ones(J,1)/x0(4),-(log(max((min_delta_cost(:,3)./(shift_bunching_sug.^2)),0))-x0(3))/(x0(4))^2,zeros(J,1)];
d_not_bunch_col3(isnan(d_not_bunch_col3)) = 0;
d_not_bunch_col4 = repmat(normpdf((log(max((min_delta_cost(:,4)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/x0(2)),[1,5]).*[-ones(J,1)/x0(2),-(log(max((min_delta_cost(:,4)./(shift_bunching_cal.^2)),0))-x0(1)-sug_pre_prod*x0(5))/(x0(2))^2,zeros(J,1),zeros(J,1),-sug_pre_prod./x0(4)];
d_not_bunch_col4(isnan(d_not_bunch_col4)) = 0;

d_bunched_sug_prob = repmat((temp(:,2)>=temp(:,3)).*bunched(:,2),[1,5]).*d_bunch_col2 + repmat((temp(:,2)<temp(:,3)).*bunched(:,3),[1,5]).*d_bunch_col3 + repmat((temp_no(:,2)>=temp_no(:,3)).*not_bunched(:,2),[1,5]).*d_not_bunch_col2 + repmat((temp_no(:,2)<temp_no(:,3)).*not_bunched(:,3),[1,5]).*d_not_bunch_col3;
d_bunched_cal_prob = repmat((temp(:,1)>=temp(:,4)).*bunched(:,1),[1,5]).*d_bunch_col1 + repmat((temp(:,1)<temp(:,4)).*bunched(:,4),[1,5]).*d_bunch_col4 + repmat((temp_no(:,1)>=temp_no(:,4)).*not_bunched(:,1),[1,5]).*d_not_bunch_col1 + repmat((temp_no(:,1)<temp_no(:,4)).*not_bunched(:,4),[1,5]).*d_not_bunch_col4;

dG = [sum(size.*(-d_bunched_cal_prob)); ...
    sum(size.*(-d_bunched_sug_prob)); ...
    sum(size.*(-d_bunched_cal_prob).*cal_pre_prod); ...
    sum(size.*(-d_bunched_sug_prob).*sug_pre_prod); ... 
    sum(size.*(-d_bunched_cal_prob).*sug_pre_prod)];

dL = 2*G'*dG;

W = eye(5);
A = dG(:,1:5)/J;
Omega = zeros(5);
for i=1:J
    Omega = Omega + (Gi(i,:)/size(i))'*(Gi(i,:));
end
Omega = Omega/J;

V = inv(A'*W*A)*(A'*W*Omega*W*A)*inv(A'*W*A)/J;


end



    

