
function [bunched_cal,bunched_sug,not_bunched_cal,not_bunched_sug,bunched_cal_prob,bunched_sug_prob,bunched_cal_late_prob,delta_cost,E_lambda,E_Lambda] = a13_predictBunching_log_Xs(x0,v,sug_pre_prod)

global shift_bunching_cal shift_bunching_cal_last1 shift_bunching_cal_last2 shift_bunching_sug min_delta_cost max_delta_cost bunched not_bunched J

rng(2019);

N = length(v);

prob_bunch = zeros(J,6,N);
prob_not_bunch = zeros(J,6,N);
delta_cost_vec=zeros(J,6,N);
Lambda_vec = zeros(2,2,N,J);
Lambda_diag = zeros(1,2,N,J);

for n=1:N
    for j=1:J    
    lambdac  = sqrt(exp(x0(1)+sug_pre_prod(j,:)*x0(5)+x0(2)*v(n,1)));
    lambdas  = sqrt(exp(x0(3)+x0(4)*v(n,2)));
    lambdacs = -sqrt(exp(-Inf));
    Cho = [lambdac,0;lambdacs,lambdas];
    
    Lambda = Cho*Cho';
    Lambda_diag(:,:,n,j) = diag(Lambda);
    Lambda_vec(:,:,n,j) = Lambda;

    delta_cost = [diag([shift_bunching_cal(j,:),0]*Lambda*[shift_bunching_cal(j,:),0]'), ...
                    diag([0,shift_bunching_sug(j,:)]*Lambda*[0,shift_bunching_sug(j,:)]'), ...
                    diag([0,shift_bunching_sug(j,:)]*Lambda*[0,shift_bunching_sug(j,:)]'), ...
                    diag([shift_bunching_cal(j,:),0]*Lambda*[shift_bunching_cal(j,:),0]'), ...
                    diag([shift_bunching_cal(j,:),shift_bunching_sug(j,:)]*Lambda*[shift_bunching_cal(j,:),shift_bunching_sug(j,:)]'), ...
                    diag([shift_bunching_cal_last2(j,:),0]*Lambda*[shift_bunching_cal_last2(j,:),0]')-diag([shift_bunching_cal_last1(j,:),0]*Lambda*[shift_bunching_cal_last1(j,:),0]')];
    prob_bunch(j,:,n) = delta_cost<max_delta_cost(j,:);
    prob_not_bunch(j,:,n) = delta_cost>=min_delta_cost(j,:);
    delta_cost_vec(j,:,n) = delta_cost;
    end
end

temp = prob_bunch.*repmat(bunched,[1,1,N]);
temp2 = (1-prob_not_bunch).*repmat(not_bunched,[1,1,N]);

bunched_sug = max(max(bunched(:,2),bunched(:,3)),bunched(:,5));
not_bunched_sug = max(max(not_bunched(:,2),not_bunched(:,3)),not_bunched(:,5));
bunched_sug_prob = sum(max(max(temp(:,2,:),temp(:,3,:)),temp(:,5,:)),3)/N + sum(max(max(temp2(:,2,:),temp2(:,3,:)),temp2(:,5,:)),3)/N;

bunched_cal = max(max(bunched(:,1),bunched(:,4)),bunched(:,5));
not_bunched_cal = max(max(not_bunched(:,1),not_bunched(:,4)),not_bunched(:,5));
bunched_cal_prob = sum(max(max(temp(:,1,:),temp(:,4,:)),temp(:,5,:)),3)/N + sum(max(max(temp2(:,1,:),temp2(:,4,:)),temp2(:,5,:)),3)/N;

bunched_cal_late_prob = sum(temp(:,6,:),3)/N + sum(temp2(:,6,:),3)/N;

bunched_once = bunched;
bunched_once(bunched_once(:,5)==1,1)=0;
bunched_once(bunched_once(:,5)==1,2)=0;
delta_cost = sum((sum(delta_cost_vec(:,1:5,:).*prob_bunch(:,1:5,:),3)./sum(prob_bunch(:,1:5,:),3)).*bunched_once(:,1:5),2);
delta_cost(isnan(delta_cost)) = max_delta_cost(isnan(delta_cost),1);

temp_lambda = permute(Lambda_diag,[4,2,3,1]);
E_lambda = sum([temp_lambda(:,1,:).*max(max(temp(:,1,:),temp(:,4,:)),temp(:,5,:)),temp_lambda(:,2,:).*max(max(temp(:,2,:),temp(:,3,:)),temp(:,5,:))],3)./sum([max(max(temp(:,1,:),temp(:,4,:)),temp(:,5,:)),max(max(temp(:,2,:),temp(:,3,:)),temp(:,5,:))],3);
E_Lambda = permute(mean(Lambda_vec,3),[1,2,4,3]);

end



    

