

disp(' ')


%% SAVE OUTPUTS


Lambda_params = param;
cost_obs = data_c;
cost_bar = data_c - delta_cost(data_product).*data_post;

save([path,'00_files/04_estimates/02_supply/01_supplyparams'],'cost_bar','Lambda_params','min_delta_cost','max_delta_cost')

prod = linspace(1,J,J)';
prod_week_store = findgroups(data_product, data_week,data_store);

T1 = table(prod,100*mu_cal_prod,10*mu_sug_prod,bunched_cal_prob,bunched_sug_prob,delta_cost,both_periods_prod,100*mu_cal_post_prod,10*mu_sug_post_prod,E_lambda_prod(:,1)/(100^2),E_lambda_prod(:,2)/(10^2),xi_j_hat(:,1),xi_j_hat(:,2));
T1.Properties.VariableNames = {'product','mu_cal','mu_sug','prob_bunch_cal_model','prob_bunch_sug_model','change_cost_model','both_periods','mu_cal_post','mu_sug_post','lambda_c_cond','lambda_s_cond','delta_j_1','delta_j_2'};
writetable(T1,[path,'00_files/04_estimates/02_supply/02_supplydata_prod.csv'],'Delimiter',',','QuoteStrings',true)

T2 = table(extractData(prod_week_store,data_market),extractData(prod_week_store,data_product),extractData(prod_week_store,cost_bar),extractData(prod_week_store,cost_obs));
T2.Properties.VariableNames = {'market','product','c_bar','c'};
writetable(T2,[path,'00_files/04_estimates/02_supply/03_supplydata_costs.csv'],'Delimiter',',','QuoteStrings',true)


%% PRINT PARAMETERS TABLE


coefficients = {'$\bar{\mu}_{\lambda}^c$','$\bar{\sigma}_{\lambda}^c$','$\bar{\mu}_{\lambda}^s$','$\bar{\sigma}_{\lambda}^s$','${\vartheta}_{\lambda}^c$'};

delete([path,'00_files/07_outputs/02_supply/01_supply_parameters.tex'])
diary([path,'00_files/07_outputs/02_supply/01_supply_parameters.tex'])
disp(char('\begin{table}[!h]'));
disp(char('\footnotesize'));
disp(char('\centering'));
disp(char('\caption{Demand parameters}'));
disp(char('\begin{tabular}{>{\raggedright}p{0.2\textwidth}cc} \hline'));

for k=1:length(coefficients)
    
    if stars_param(k)==0
        star='';
    elseif stars_param(k)==1
        star='$^{\ast}$';
    elseif stars_param(k)==2
        star='$^{\ast \ast}$';
    elseif stars_param(k)==3
        star='$^{\ast \ast \ast}$';
    end
    disp([coefficients{k},' & ',num2str(param(k)),star,' \\ [0.1em]'])
    disp([' & (',num2str(sd_param(k)),') \\ [0.7em]'])
    
end

disp(char(['\hline']));
disp(char(['\hline']));
disp(char(['\end{tabular}']));
disp(char(['\end{table}']));
disp(' ');
diary off