
function [output,weekly_profitb] = a06_calculateProfits(x0,selected_prod,bunching_cal,bunching_sug,stage)

global M N J minerror maxIter profit_sim week firm market product l_cal l_sug exempted Elab_cal Elab_sug mu_cal mu_sug Enolab_cal Enolab_sug post s c p fineline_wide weights_wide market_wide p_wide week_wide alpha_wide rho_wide firm_structure ...
    market_size_bins portion_size_bins

    selected_firm = mean(firm(product==selected_prod));
    
    profit_firm = profit_sim(firm==selected_firm);
    week_firm = week(firm==selected_firm);
    weekly_profit = accumarray(week_firm,profit_firm);
    
    if strcmp(stage,'first')
        
        lb_cal = l_cal;
        lb_cal(product==selected_prod)  = bunching_cal;
        lb_cal = lb_cal.*(1-exempted);
        Eb_cal = mu_cal + (post.*lb_cal.*(1-exempted)).*Elab_cal + (post.*(1-lb_cal).*(1-exempted)).*Enolab_cal;
        Eb_cal_wide = [reshape(Eb_cal,[J,M*N])',zeros(M*N,1)];

        lb_sug = l_sug;
        lb_sug(product==selected_prod)  = bunching_sug;
        lb_sug = lb_sug.*(1-exempted);
        Eb_sug = mu_sug + (post.*lb_sug.*(1-exempted)).*Elab_sug + (post.*(1-lb_sug).*(1-exempted)).*Enolab_sug;
        Eb_sug_wide = [reshape(Eb_sug,[J,M*N])',zeros(M*N,1)];

    elseif strcmp(stage,'last')

        late_threshold = 2.75;
        
        Eb_cal = mu_cal + (post.*l_cal.*(1-exempted)).*Elab_cal + (post.*(1-l_cal).*(1-exempted)).*Enolab_cal;
        Eb_cal(product==selected_prod & exempted==0 & Eb_cal > late_threshold & post==1)  = late_threshold;
        Eb_cal_wide = [reshape(Eb_cal,[J,M*N])',zeros(M*N,1)];
        
        Eb_sug = mu_sug + (post.*l_sug.*(1-exempted)).*Elab_sug + (post.*(1-l_sug).*(1-exempted)).*Enolab_sug;
        Eb_sug_wide = [reshape(Eb_sug,[J,M*N])',zeros(M*N,1)];
        
    end
    
    weekly_extra_cost = [0;x0];

    weekly_extra_cost = weekly_extra_cost(post+1).*(product==selected_prod);
    cb = c+weekly_extra_cost;
    pb = p;
    
    error = 10;
    iter = 1;
    
    while(abs(error)>minerror && iter<maxIter)
    
    
    pb_wide = [reshape(pb,[J,N*M])',zeros(N*M,1)];
    [sb_wide,sb_g_wide] = a04_calculateShares(pb_wide,Eb_cal_wide,Eb_sug_wide);
    sb = reshape(sb_wide(:,1:J)',[J*M*N,1]);
    if strcmp(firm_structure,'simple') || strcmp(firm_structure,'single')
        weighted_shares = sb_wide.*weights_wide;
        weighted_derivative = (alpha_wide./(1-rho_wide)).*sb_wide.*(1-(rho_wide.*sb_g_wide+(1-rho_wide).*sb_wide)).*weights_wide;
        s_m_wide = expand(cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),weighted_shares(:,x)),1:J+1,'un',0)),[N,1]);
        ds_m_wide = expand(cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),weighted_derivative(:,x)),1:J+1,'un',0)),[N,1]);
        pb1 = cb + reshape(s_m_wide(:,1:J)',[J*N*M,1])./reshape(ds_m_wide(:,1:J)',[J*N*M,1]);
        pb1(isnan(pb1)) = Inf;
    else
        [markupb] = a05_calculateMarkup(sb_wide,sb_g_wide);
        pb1 = cb + markupb;
    end
    if iter<maxIter/3
        pb1 = (pb1+1*pb)/2;
    else
        pb1 = (pb1+49*pb)/50;
    end
    error = (pb(s>0)-pb1(s>0))'*(pb(s>0)-pb1(s>0));
    
    if iter==maxIter
        disp('WARNING: Max number of iterations reached')
    end
    
    iter = iter+1;
    pb = pb1;
    
    end
    
    profitb = (pb-cb).*sb.*market_size_bins.*portion_size_bins/(N/2);
    profitb(isnan(profitb)) = 0;
    
    profitb_firm = profitb(firm==selected_firm);
    weekly_profitb = accumarray(week_firm,profitb_firm);
    
    output = (sum(weekly_profit-weekly_profitb))'*(sum(weekly_profit-weekly_profitb));

end




