
%% SIMULATIONS

CF = 7;

outcomes = cell(CF,1);
tax = [0,0];

tic

display('INITIALIZING VARIABLES...')
% GENERATE SIMULATION VARIABLES
data_Lambda = genLambda(Lambda_params,sug_prod);
a02_exogenousVars;

disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

display('RUNNING NO POLICY COUNTERFACTUAL...')
outcomes{1} = a03_equilibrium('no',wbar,tax);
%disp(['consumer surplus: ',num2str(mean(CS{1}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

price_nointervention = outcomes{1}(:,2);

display('RUNNING DEMAND ONLY COUNTERFACTUAL...')
outcomes{2} = a03_equilibrium('only_demand',wbar,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{2}(r,ii)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

display('RUNNING NO BUNCHING COUNTERFACTUAL...')
outcomes{3} = a03_equilibrium('no_bunching',wbar,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{3}(r,:)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

display('RUNNING EQUILIBRIUM BUNCHING COUNTERFACTUAL...')
outcomes{4} = a03_equilibrium('equilibrium',wbar,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{4}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

display('RUNNING PERFECT INFORMATION DEMAND ONLY COUNTERFACTUAL...')
outcomes{5} = a03_equilibrium('perfect_demand',wbar,tax);    
%disp(['consumer surplus: ',num2str(mean(CS{5}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

display('RUNNING PERFECT INFORMATION NO BUNCHING COUNTERFACTUAL...')
outcomes{6} = a03_equilibrium('perfect_no_bunching',wbar,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{6}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

display('RUNNING PERFECT INFORMATION EQUILIBRIUM COUNTERFACTUAL...')
outcomes{7} = a03_equilibrium('perfect_equilibrium',wbar,tax);    
%disp(['consumer surplus: ',num2str(mean(CS{7}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')


disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')
disp(' ')
disp(' ')




save([path,'00_files/05_counterfactuals/01_policyEvaluation/01_simulations/results_',int2str(iter)],'outcomes','-v7.3')


