
%% SIMULATIONS

CF = 9;

outcomes = cell(CF,W);
tax = [0,0];

tic

disp('INITIALIZING VARIABLES...')
% GENERATE SIMULATION VARIABLES
a02_exogenousVars;
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

display('RUNNING NO POLICY COUNTERFACTUAL...')
outcomes{1,1} = a03_equilibrium('no',wbar,tax);
%disp(['consumer surplus: ',num2str(mean(CS{1}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

price_nointervention = outcomes{1}(:,2);

disp('RUNNING DEMAND ONLY COUNTERFACTUAL...')
for ii = simulation_bins{sim_bin}
if strcmp(nut_labeled,'calories')
    disp(['iteration wbar=',num2str(calbar(ii))]);
    wbar1 = [calbar(ii),wbar(2)];
elseif strcmp(nut_labeled,'sugar')
    disp(['iteration wbar=',num2str(sugbar(ii))]);
    wbar1 = [wbar(1),sugbar(ii)];
end
outcomes{2,ii} = a03_equilibrium('only_demand',wbar1,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{2}(r,ii)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')
end

disp('RUNNING NO BUNCHING COUNTERFACTUAL...')
for ii = simulation_bins{sim_bin}
if strcmp(nut_labeled,'calories')
    disp(['iteration wbar=',num2str(calbar(ii))]);
    wbar1 = [calbar(ii),wbar(2)];
elseif strcmp(nut_labeled,'sugar')
    disp(['iteration wbar=',num2str(sugbar(ii))]);
    wbar1 = [wbar(1),sugbar(ii)];
end
outcomes{3,ii} = a03_equilibrium('no_bunching',wbar1,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{3}(r,:)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')
end

disp('RUNNING EQUILIBRIUM BUNCHING COUNTERFACTUAL...')
for ii = simulation_bins{sim_bin}
if strcmp(nut_labeled,'calories')
    disp(['iteration wbar=',num2str(calbar(ii))]);
    wbar1 = [calbar(ii),wbar(2)];
elseif strcmp(nut_labeled,'sugar')
    disp(['iteration wbar=',num2str(sugbar(ii))]);
    wbar1 = [wbar(1),sugbar(ii)];
end
outcomes{4,ii} = a03_equilibrium('equilibrium',wbar1,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{4}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')
end

disp('RUNNING PERFECT INFORMATION DEMAND ONLY COUNTERFACTUAL...')
outcomes{5,1} = a03_equilibrium('perfect_demand',wbar,tax);    
%disp(['consumer surplus: ',num2str(mean(CS{5}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

disp('RUNNING PERFECT INFORMATION NO BUNCHING COUNTERFACTUAL...')
outcomes{6,1} = a03_equilibrium('perfect_no_bunching',wbar,tax);   
%disp(['consumer surplus: ',num2str(mean(CS{6}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

disp('RUNNING PERFECT INFORMATION EQUILIBRIUM COUNTERFACTUAL...')
outcomes{7,1} = a03_equilibrium('perfect_equilibrium',wbar,tax);    
%disp(['consumer surplus: ',num2str(mean(CS{7}(r)))]);
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')

disp('RUNNING TAXES ONLY DEMAND...')
for ii = simulation_bins{sim_bin}
    if strcmp(nut_labeled,'calories')
        disp(['iteration calories tax = ',num2str(caltax(ii))]);
        tax = [caltax(ii),0];
    elseif strcmp(nut_labeled,'sugar')
        disp(['iteration sugar tax = ',num2str(sugtax(ii))]);
        tax = [0,sugtax(ii)];
    end
        outcomes{8,ii} = a03_equilibrium('tax_demand',wbar,tax);
        disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
        disp(' ')
end

disp('RUNNING TAXES EQUILIBRIUM...')
for ii = simulation_bins{sim_bin}
    if strcmp(nut_labeled,'calories')
        disp(['iteration calories tax = ',num2str(caltax(ii))]);
        tax = [caltax(ii),0];
    elseif strcmp(nut_labeled,'sugar')
        disp(['iteration sugar tax = ',num2str(sugtax(ii))]);
        tax = [0,sugtax(ii)];
    end
        outcomes{9,ii} = a03_equilibrium('tax_equilibrium',wbar,tax);
        disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
        disp(' ')
end


disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
disp(' ')
disp(' ')
disp(' ')


save([path,'00_files/05_counterfactuals/02_policyCounterfactuals/01_simulations/results_',int2str(iter),'_bins_',int2str(sim_bin)],'outcomes','-v7.3')



