
%% load results

function [output] = b01_loadResults(iter)

global M N J data_product product_wide

path = '../../';
%path = './';
addpath([path,'04_counterfactuals/02_policyCounterfactuals/'])
addpath([path,'04_counterfactuals/98_simulation_codes/'])
addpath([path,'04_counterfactuals/99_functions/'])

exemption_mode = 'no'; %no/yes 
nut_labeled = 'sugar'; %calories/sugar/both
smoot_vars = "yes";

W = 23;
mincal = 240;
maxcal = 460;
minsug = 2.5;
maxsug = 42.5;
calbar = [200,linspace(mincal,maxcal,W-2),500];
sugbar = [0,linspace(minsug,maxsug,W-2),50];
mincal = 0;
maxcal = 0.003;
minsug = 0;
maxsug = 0.005;
caltax = linspace(mincal,maxcal,W);
sugtax = linspace(minsug,maxsug,W);

simulation_bins = {[1,7,13,19],[2,8,14,20],[3,9,15,21],[4,10,16,22],[5,11,17,23],[6,12,18]};

if strcmp(nut_labeled,'sugar')
    bar = sugbar;
    taxidx = 2;
elseif strcmp(nut_labeled,'calories')
    bar = calbar;
    taxidx = 1;
end

a01_parameters;
a02_exogenousVars;

alpha_param = reshape(alpha_wide(:,1:J)',[J*M*N,1]);
phi_cal_param = reshape(phi_cal_wide(:,1:J)',[J*M*N,1]);
phi_sug_param = reshape(phi_sug_wide(:,1:J)',[J*M*N,1]);
individual_id = findgroups(alpha_param,phi_cal_param,phi_sug_param);
week_type = findgroups(week,individual_id);
product_type = findgroups(product,individual_id);
market_type = findgroups(market,individual_id);

N = 40;
Num = 0;
table = [];

it_1 = 10*(iter-1)+1;
it_2 = 10*iter;

for it=it_1:it_2 
for sim_bin = 1:6
if isfile([path,'00_files/05_counterfactuals/02_policyCounterfactuals/01_simulations/results_',int2str(it),'_bins_',int2str(sim_bin),'.mat'])
    Num = Num+1;
    display(['loading data from iteration: ',int2str(it),', bins: ',int2str(sim_bin)])
    
    load([path,'00_files/05_counterfactuals/02_policyCounterfactuals/01_simulations/results_',int2str(it),'_bins_',int2str(sim_bin)]);
       
    for citer = 1:9
        
        for wit = simulation_bins{sim_bin}
            if ismember(citer,[1,5,6,7])
                witer = 1;
            else
                witer = wit;
            end
            
            sb = outcomes{1,1}(:,1);
            s = outcomes{citer,witer}(:,1);
            p = outcomes{citer,witer}(:,2);
            c = outcomes{citer,witer}(:,3);
            cal = outcomes{citer,witer}(:,4);
            sug = outcomes{citer,witer}(:,5);
            cs = outcomes{citer,witer}(:,6);
            tax = [0,0];
            if strcmp(nut_labeled,'calories') && ismember(citer,[8,9])
                tax = [caltax(witer),0];
            elseif strcmp(nut_labeled,'sugar') && ismember(citer,[8,9])
                tax = [0,sugtax(witer)];
            end
            
            temp = accumarray(market_type,s);
            s0 = 1-temp(market_type);

            % weekly outcomes
            id_tot = extractData(individual_id(sb>0 & week>=7),individual_id(sb>0 & week>=7));
            type_tot = extractData(individual_id(sb>0 & week>=7),individual_type(sb>0 & week>=7));
            alpha_tot = extractData(individual_id(sb>0 & week>=7),alpha_param(sb>0 & week>=7));
            phi_cal_tot = extractData(individual_id(sb>0 & week>=7),phi_cal_param(sb>0 & week>=7));
            phi_sug_tot = extractData(individual_id(sb>0 & week>=7),phi_sug_param(sb>0 & week>=7));
            cs_tot = accumarray(individual_id(sb>0 & week>=7),10*cs(sb>0 & week>=7).*s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7)./(1-s0(sb>0 & week>=7)));
            q_tot = accumarray(individual_id(sb>0 & week>=7),s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            cal_tot = accumarray(individual_id(sb>0 & week>=7),10*cal(sb>0 & week>=7).*s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            sug_tot = accumarray(individual_id(sb>0 & week>=7),10*sug(sb>0 & week>=7).*s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            price_tot = accumarray(individual_id(sb>0 & week>=7),10*p(sb>0 & week>=7).*s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            cost_tot = accumarray(individual_id(sb>0 & week>=7),10*c(sb>0 & week>=7).*s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            taste_tot = accumarray(individual_id(sb>0 & week>=7),10*xi_sum(sb>0 & week>=7).*s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            tax_tot = accumarray(individual_id(sb>0 & week>=7),10*(tax(1)*post(sb>0 & week>=7).*(1-exempted(sb>0 & week>=7)).*cal(sb>0 & week>=7) + tax(2)*post(sb>0 & week>=7).*(1-exempted(sb>0 & week>=7)).*sug(sb>0 & week>=7)).*s(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            base_q = accumarray(individual_id(sb>0 & week>=7),sb(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            base_cal = accumarray(individual_id(sb>0 & week>=7),10*cal(sb>0 & week>=7).*sb(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            base_sug = accumarray(individual_id(sb>0 & week>=7),10*sug(sb>0 & week>=7).*sb(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            base_price = accumarray(individual_id(sb>0 & week>=7),10*p(sb>0 & week>=7).*sb(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));
            base_cost = accumarray(individual_id(sb>0 & week>=7),10*c(sb>0 & week>=7).*sb(sb>0 & week>=7).*portion_size_bins(sb>0 & week>=7).*market_size_bins(sb>0 & week>=7));

            table = [table;it*ones(N,1),citer*ones(N,1),bar(wit)*ones(N,1),tax(taxidx)*ones(N,1),id_tot,type_tot,cs_tot,q_tot,cal_tot,sug_tot,price_tot,cost_tot,taste_tot,tax_tot,base_q,base_cal,base_sug,base_price,base_cost,alpha_tot,phi_cal_tot,phi_sug_tot];

        end
        
        
    end
    
    
    
end
end
end
    
    
T1 = array2table(table);
T1.Properties.VariableNames = {'sim','counterfactual','threshold','tax','id','type','cs','q','cal','sug','price','cost','taste','taxcol','q_b','cal_b','sug_b','price_b','cost_b','alpha','phi_cal','phi_sug'};  
writetable(T1,[path,'00_files/05_counterfactuals/02_policyCounterfactuals/01_simulations/01_results_',int2str(iter),'.csv'],'Delimiter',',','QuoteStrings',true)
   

output = [];

end
