    
%% main sript

function [output] = a00_main(rho_value)


rng(2019)

path = './../../../';
addpath([path,'03_estimation/99_functions/'])
addpath([path,'03_estimation/02_supply/'])

fprintf('\n------------------------------------------------------------\n');
fprintf(' SUPPLY MODEL ESTIMATION ');
disp(' ');
disp(['Rho-level: ', int2str(rho_value)]);
fprintf('\n------------------------------------------------------------\n');

global M J N F minerror maxIter beta0 gamma alpha phi_cal phi_sug rho Sigma market alpha_wide phi_cal_wide phi_sug_wide beta_fine_wide beta0_wide ...
    data_product product_wide firm_wide profit_sim week firm product l_cal l_sug exempted Elab_cal Elab_sug Elab_cal_late Elab_sug_late mu_cal mu_sug  Enolab_cal Enolab_sug Enolab_cal_late Enolab_sug_late post s s_g c p fineline_wide ...
    market_wide p_wide week_wide firm_structure size fineline_prod xi_j_wide xi_t_wide xi_s_wide xi_wide weights_wide rho_wide market_size_bins portion_size_bins cal_late sug_late ing_prod

opts = optimset( 'Display','final','MaxIter',100000,'Tolx',1e-24,'Tolfun',1e-10,'MaxFunEvals',1000000);
  
disp(' ')

disp('1. loading data..')
a01_loadData_robust;

disp('2. defining variables..')
a02_exogenousVars;

disp('3. recovering marginal costs..')
a03_recoverCosts_robust;

disp('6. minimizing moment conditions..')
a06_estimation;

disp('8. saving output..')
a04_saveData_robust;

output=[];


end
