
%% Load data

disp(' ')

load([path,'00_files/05_counterfactuals/03_robustness/01_demandparams_r',int2str(rho_value)])


% DEFINE VARIABLES
data_week = data(:,1);
data_week = findgroups(data_week);
data_store = data(:,2);
data_store = findgroups(data_store);
data_market = data(:,3);
data_market = findgroups(data_market);
data_market_bin = data(:,4);
data_market_bin = findgroups(data_market_bin);
data_product = data(:,5);
data_brand = data(:,6);
data_holding = data(:,55);
data_fineline = data(:,7);
data_healthy = data(:,8);
data_exempted = data(:,9);
data_s = data(:,10);
data_s_g = data(:,12);
data_p = data(:,15);
data_ingr = data(:,177:181);

data_sug = data(:,16);
data_sug_pre = data(:,17);
data_sug_late = data(:,50);
data_cal = data(:,18);
data_cal_pre = data(:,19);
data_cal_late = data(:,51);
data_post = data(:,20);
data_L_sug = data(:,21);
data_l_sug = data(:,22);
data_L_cal = data(:,23);
data_l_cal = data(:,24);

data_market_size = data(:,37);
data_market_size_bin = data(:,38);
data_portion_size = data(:,39);
data_portion_size_bin = data(:,40);
data_individual_type = data(:,41);

data_mu_sug = data(:,25);
data_mu_cal = data(:,26);
data_mu_sug_hom = data(:,46);
data_mu_cal_hom = data(:,47);

data_week_bin = findgroups(data_individual_type,data_week);
data_store_bin = findgroups(data_individual_type,data_store);
data_product_bin = findgroups(data_individual_type,data_product);



% SAMPLE SIZE 
J = max(data_product); % products (94)
S = max(data_store); % store (160)
T = max(data_week); % periods (17)
M = max(data_market); % markets
F = max(data_fineline); % number of finelines (6)
N = 2*length(vp_ind(:,1)); % number of individual types (40)


% DEMAND PARAMETERS (as in draft)
beta0 = beta0_hat;
gamma = 0;
phi_cal = phi_cal_hat;
phi_sug = phi_sug_hat;
alpha = alpha_hat;
rho = rho_hat(1);

% random coefficients variance
Sigma = Sigma_hat; 


% BELIEFS PARAMETERS
sigma_mu = sigma_mu_hat;

% POLICY
wbar = [3.5,2.25]; % This is the threshold
wbar2 = [2.75,1]; % This is the threshold at stage 3


% CONVERGENCE FOR FIXED POINT PARAMETERS
minerror = 0.0001;
maxIter = 1000;

% OPTIMIZATION PARAMETERS
Nsim = 50000;
%[v_sim, w_sim] = nwspgr('GQN', Nsim, 3);
v_sim = linspace(Nsim/10000,9999*Nsim/10000,Nsim)'/Nsim;
v_sim = norminv(v_sim);
v_sim = [v_sim(randperm(length(v_sim))),v_sim(randperm(length(v_sim))),v_sim(randperm(length(v_sim)))];


