

%% Recover costs from paralell estimation

function [output] = c01_aggResults(rho_value)

rng(2019)

path = './../../../';
addpath([path,'03_estimation/99_functions/'])
addpath([path,'03_estimation/02_supply/'])

global M J N F minerror maxIter beta0 gamma alpha phi_cal phi_sug rho Sigma market alpha_wide phi_cal_wide phi_sug_wide beta_fine_wide beta0_wide ...
    data_product product_wide firm_wide profit_sim week firm product l_cal l_sug exempted Elab_cal Elab_sug Elab_cal_late Elab_sug_late mu_cal mu_sug  Enolab_cal Enolab_sug Enolab_cal_late Enolab_sug_late post s s_g c p fineline_wide ...
    market_wide p_wide week_wide firm_structure size fineline_prod xi_j_wide xi_t_wide xi_s_wide xi_wide weights_wide rho_wide market_size_bins portion_size_bins cal_late sug_late ing_prod

disp(' ')

disp('1. loading data..')
a01_loadData_robust;

disp('2. defining variables..')
a02_exogenousVars;

disp(' ')

extracost_perweek_final = {zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week))};
fval_perweek_final = {zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week)),zeros(J,max(week))};

Num = 0;

for j=1:94 
    
if isfile([path,'00_files/05_counterfactuals/03_robustness/temp/ind_cost_curve_',int2str(rho_value),'_prod_',int2str(j),'.mat'])
    Num = Num+1;
    display(['loading data from product: ',int2str(j)])
    
    load([path,'00_files/05_counterfactuals/03_robustness/temp/ind_cost_curve_',int2str(rho_value),'_prod_',int2str(j)]);
    
    for i = 1:5
        
        extracost_perweek_final{i}(j,:) = extracost_perweek{i}(j,:);
        fval_perweek_final{i}(j,:) = fval_perweek{i}(j,:);
        
    end
    
end
end
    
extracost_perweek = extracost_perweek_final;
fval_perweek = fval_perweek_final;

save([path,'00_files/05_counterfactuals/03_robustness/temp/ind_cost_curve_',int2str(rho_value)],'extracost_perweek','fval_perweek')

