
%% Define parameters



disp(' ')
    
load([path,'00_files/05_counterfactuals/03_robustness/01_demandparams_r',int2str(rho_value)])
load([path,'00_files/05_counterfactuals/03_robustness/02_supplyparams_',int2str(rho_value)])


% DEFINE ORIGINAL DATA VARIABLES
data_week = data(:,1);
data_week = findgroups(data_week);
data_store = data(:,2);
data_store = findgroups(data_store);
data_market = data(:,3);
data_market = findgroups(data_market);
data_market_bin = data(:,4);
data_market_bin = findgroups(data_market_bin);
data_product = data(:,5);
data_brand = data(:,6);
data_holding = data(:,55);
data_fineline = data(:,7);
data_healthy = data(:,8);
data_exempted = data(:,9);
data_s = data(:,10);
data_s_g = data(:,12);
data_p = data(:,15);
data_ingr = data(:,177:181);

data_sug = data(:,16);
data_sug_pre = data(:,17);
data_cal = data(:,18);
data_cal_pre = data(:,19);
data_post = data(:,20);
data_L_sug = data(:,21);
data_l_sug = data(:,22);
data_L_cal = data(:,23);
data_l_cal = data(:,24);

data_market_size = data(:,37);
data_market_size_bin = data(:,38);
data_portion_size = data(:,39);
data_portion_size_bin = data(:,40);
data_individual_type = data(:,41);

data_bunched_cal = (data_cal <= 350 & data_cal_pre > 350 ).*(1-data_exempted);
data_bunched_sug = (data_sug <= 22.5 & data_sug_pre > 22.5 ).*(1-data_exempted);
data_mu_cal = 100*muw_hat(:,1);
data_mu_sug = 10*muw_hat(:,2);
data_sigmamu_cal = sigma_mu_hat(:,1)*100;
data_sigmamu_sug = sigma_mu_hat(:,2)*10;

data_week_bin = findgroups(data_individual_type,data_week);
data_store_bin = findgroups(data_individual_type,data_store);
data_product_bin = findgroups(data_individual_type,data_product);


% SAMPLE SIZE 
J = max(data_product); % products (94)
S = max(data_store); % store (160)
T = max(data_week); % periods (17)
M = max(data_market); % markets
F = max(data_fineline); % number of finelines (6)
N = 2*length(vp_ind(:,1)); % number of individual types (40)

% POLICY PARAMETERS
wbar = [350,22.5];


% DEMAND PARAMETERS (as in draft)
beta0 = beta0_hat;
gamma = 0;
phi_cal = phi_cal_hat;
phi_sug = phi_sug_hat;
alpha = alpha_hat;
rho = rho_hat(1);

% random coefficients variance
Sigma = Sigma_hat; 


% BELIEFS PARAMETERS
sigma_mu = sigma_mu_hat;


% SUPPLY PARAMETERS
sug_prod = extractData(data_product,data_sug_pre)/10;
data_Lambda = genLambda(Lambda_params,sug_prod);
C = @(w,c,Lambda) c + sum(w.*w.*Lambda,2);


% CONVERGENCE FOR FIXED POINT PARAMETERS
minerror = 0.001;
minerror_final = 0.000001;
maxIter = 5000;

