
%% We create all exogenous variables

disp(' ')

% We do everything on a wide panel structure

% firm and market id
product_wide = [repmat(extractData(data_product, data_product)',[M*N,1]),zeros(M*N,1)]; 
market_wide = repmat(expand(extractData(data_market_bin, data_market),[N/2,1]),[1,J+1]);
market_bin_wide = repmat(expand(extractData(data_market_bin, data_market_bin),[N/2,1]),[1,J+1]);
market_size_wide = repmat(expand(extractData(data_market_bin, data_market_size),[N/2,1]),[1,J+1]);
portion_size_wide = repmat(expand(extractData(data_market_bin, data_portion_size),[N/2,1]),[1,J+1]);
week_wide = repmat(expand(extractData(data_market_bin, data_week),[N/2,1]),[1,J+1]);
post_wide = repmat(expand(extractData(data_market_bin, data_post),[N/2,1]),[1,J+1]);
store_wide = repmat(expand(extractData(data_market_bin, data_store),[N/2,1]),[1,J+1]);
individual_type_wide = repmat(expand(extractData(data_market_bin, data_individual_type),[N/2,1]),[1,J+1]);
firm_wide = [repmat(extractData(data_product, data_brand)',[M*N,1]),zeros(M*N,1)];
holding_wide = [repmat(extractData(data_product, data_holding)',[M*N,1]),zeros(M*N,1)];


% market size by bins
market_size_bins_wide = repmat(expand(extractData(data_market_bin, data_market_size_bin),[N/2,1]),[1,J+1]);
portion_size_bins_wide = repmat(expand(extractData(data_market_bin, data_portion_size_bin),[N/2,1]),[1,J+1]);
weights_wide = (market_size_bins_wide.*portion_size_bins_wide)./repmat(2*expand(extractData(extractData(data_market_bin, data_market), extractData(data_market_bin, data_market_size_bin.*data_portion_size_bin)),[N,1]),[1,J+1])/(N/2);

% bunching variables
bunched_cal_ori_wide = [repmat(extractData(data_product, data_bunched_cal)',[M*N,1]),zeros(M*N,1)];
bunched_cal_ori_wide = ceil(bunched_cal_ori_wide).*post_wide;
bunched_cal_ori_prod = ceil(extractData(data_product, data_bunched_cal));
bunched_sug_ori_wide = [repmat(extractData(data_product, data_bunched_cal)',[M*N,1]),zeros(M*N,1)];
bunched_sug_ori_wide = ceil(bunched_sug_ori_wide).*post_wide;
bunched_sug_ori_prod = ceil(extractData(data_product, data_bunched_sug));
bunched_ori_prod = [0,0;bunched_cal_ori_prod,bunched_sug_ori_prod];

post_wide(post_wide==0) = 1;

% demand characteristics
xi_j_wide = [repmat([expand(xi_j_hat(:,1)',[N/2,1]);expand(xi_j_hat(:,2)',[N/2,1])],[M,1]),zeros(N*M,1)];
temp = [xi_t_hat(:,1);xi_t_hat(:,2)];
xi_t_wide = [repmat(expand(extractData(data_market_bin,temp(data_week_bin)),[N/2,1]),[1,J]),zeros(N*M,1)];
temp = [xi_s_hat(:,1);xi_s_hat(:,2)];
xi_s_wide = [repmat(expand(extractData(data_market_bin,temp(data_store_bin)),[N/2,1]),[1,J]),zeros(N*M,1)];
% bootstraping residuals at the market level:
obsIDX = linspace(1,length(xi_hat), length(xi_hat))';
rndIDX = [];
for m=1:M*2
    rndIDX = [rndIDX;randsample(obsIDX(data_market_bin==m),length(obsIDX(data_market_bin==m)),true)];
end
xi_wide = fillPanel(xi_hat(rndIDX),-Inf);
%                                           %
fineline_wide = [repmat(extractData(data_product, data_fineline)',[N*M,1]),zeros(N*M,1)]; 
healthy_wide = [repmat(extractData(data_product, data_healthy)',[N*M,1]),zeros(N*M,1)];  
exempted_wide = [repmat(extractData(data_product, data_exempted)',[N*M,1]),zeros(N*M,1)];  
if strcmp(exemption_mode,'no')
    exempted_wide = 0*exempted_wide;
end

% supply characteristics
nu_cal_wide = [repmat(extractData(data_product, data_cal_pre)',[N*M,1]),zeros(N*M,1)];
nu_sug_wide = [repmat(extractData(data_product, data_sug_pre)',[N*M,1]),zeros(N*M,1)];
Lambda_cal_wide = [repmat(extractData(data_product, data_Lambda(:,1))',[N*M,1]),zeros(N*M,1)];
Lambda_sug_wide = [repmat(extractData(data_product, data_Lambda(:,2))',[N*M,1]),zeros(N*M,1)];
%c_wide = fillPanel(cost_bar,Inf);
c_wide = fillPanel(cost_bar,NaN);
c_wide = expand(cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),c_wide(:,x),[],@(x)mean(x,'omitnan')),1:J+1,'un',0)),[N,1]);
c_wide(isnan(c_wide))=Inf;


% priors and policy
temp = extractData(data_product_bin, data_mu_cal);
mu_cal_wide = [repmat(expand([temp(1:J)';temp(J+1:2*J)'],[N/2,1]),[M,1]),zeros(N*M,1)];
temp = extractData(data_product_bin, data_mu_sug);
mu_sug_wide = [repmat(expand([temp(1:J)';temp(J+1:2*J)'],[N/2,1]),[M,1]),zeros(N*M,1)];
temp = extractData(data_product_bin, data_sigmamu_cal);
sigmamu_cal_wide = [repmat(expand([temp(1:J)';temp(J+1:2*J)'],[N/2,1]),[M,1]),zeros(N*M,1)];
temp = extractData(data_product_bin, data_sigmamu_sug);
sigmamu_sug_wide = [repmat(expand([temp(1:J)';temp(J+1:2*J)'],[N/2,1]),[M,1]),zeros(N*M,1)];

%%%%%%%%%% SMOOTH NU AND MU FOR COUNTERFACTUAL SIMULATIONS %%%%%%%%%%%
if strcmp(smoot_vars,"yes")
norm_nu_mu = [extractData(data_product, data_cal_pre),extractData(data_product, data_sug_pre), ...
    extractData(data_product(data_individual_type==1), data_mu_cal(data_individual_type==1)), ...
    extractData(data_product(data_individual_type==1), data_mu_sug(data_individual_type==1)), ...
    extractData(data_product(data_individual_type==2), data_mu_cal(data_individual_type==2)), ...
    extractData(data_product(data_individual_type==2), data_mu_sug(data_individual_type==2))];
norm_weights = accumarray( data_product, data_p.*data_s.*(1-data_post).*data_portion_size_bin.*data_market_size_bin);
norm_weights = norm_weights/sum(norm_weights);
norm_means = sum(norm_nu_mu.*repmat(norm_weights,[1,6]));
norm_corr = weightedcorrs(norm_nu_mu, norm_weights);
norm_sigma = weightedcov(norm_nu_mu, norm_weights);
norm_vars = mvnrnd(norm_means,norm_sigma,J);

nu_cal_wide = [repmat(norm_vars(:,1)',[N*M,1]),zeros(N*M,1)];
nu_cal_wide(nu_cal_wide<0) = 0;
nu_sug_wide = [repmat(norm_vars(:,2)',[N*M,1]),zeros(N*M,1)];
nu_sug_wide(nu_sug_wide<0) = 0;
mu_cal_wide = [repmat([repmat(norm_vars(:,3),[1,N/2]),repmat(norm_vars(:,5),[1,N/2])]',[M,1]),zeros(N*M,1)];
mu_cal_wide(mu_cal_wide<0) = 0;
mu_sug_wide = [repmat([repmat(norm_vars(:,4),[1,N/2]),repmat(norm_vars(:,6),[1,N/2])]',[M,1]),zeros(N*M,1)];
mu_sug_wide(mu_sug_wide<0) = 0;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% endogenous variables
p_ori_wide = fillPanel(data_p,NaN);
p_ori_wide = expand(cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),p_ori_wide(:,x),[],@(x)mean(x,'omitnan')),1:J+1,'un',0)),[N,1]);
p_ori_wide(isnan(p_ori_wide))=Inf;
%p_ori_wide = fillPanel(data_p,Inf);
s_ori_wide = fillPanel(data_s,0);
s_g_ori_wide = fillPanel(data_s_g,0);
l_cal_ori_wide = fillPanel(data_l_cal,0);
l_sug_ori_wide = fillPanel(data_l_sug,0);


% We reshape for a long panel structure
xi_j = reshape(xi_j_wide(:,1:J)',[J*M*N,1]);
xi_t = reshape(xi_t_wide(:,1:J)',[J*M*N,1]);
xi_s = reshape(xi_s_wide(:,1:J)',[J*M*N,1]);
xi = reshape(xi_wide(:,1:J)',[J*M*N,1]);
Lambda_cal = reshape(Lambda_cal_wide(:,1:J)',[J*M*N,1]);
Lambda_sug = reshape(Lambda_sug_wide(:,1:J)',[J*M*N,1]);
Lambda = [Lambda_cal, Lambda_sug];
nu_cal = reshape(nu_cal_wide(:,1:J)',[J*M*N,1]);
nu_sug = reshape(nu_sug_wide(:,1:J)',[J*M*N,1]);
nu = [nu_cal,nu_sug];
mu_cal = reshape(mu_cal_wide(:,1:J)',[J*M*N,1]);
mu_sug = reshape(mu_sug_wide(:,1:J)',[J*M*N,1]);
mu = [mu_cal,mu_sug];
c = reshape(c_wide(:,1:J)',[J*M*N,1]);
post = reshape(post_wide(:,1:J)',[J*M*N,1]);
product = reshape(product_wide(:,1:J)',[J*M*N,1]);
fineline = reshape(fineline_wide(:,1:J)',[J*M*N,1]);
healthy = reshape(healthy_wide(:,1:J)',[J*M*N,1]);
firm = reshape(firm_wide(:,1:J)',[J*M*N,1]);
market = reshape(market_wide(:,1:J)',[J*M*N,1]);
market_bin = reshape(market_bin_wide(:,1:J)',[J*M*N,1]);
individual_type = reshape(individual_type_wide(:,1:J)',[J*M*N,1]);
week = reshape(week_wide(:,1:J)',[J*M*N,1]);
store = reshape(store_wide(:,1:J)',[J*M*N,1]);
exempted = reshape(exempted_wide(:,1:J)',[J*M*N,1]);
p_ori = reshape(p_ori_wide(:,1:J)',[J*M*N,1]);
s_ori = reshape(s_ori_wide(:,1:J)',[J*M*N,1]);
l_cal_ori = reshape(l_cal_ori_wide(:,1:J)',[J*M*N,1]);
l_sug_ori = reshape(l_sug_ori_wide(:,1:J)',[J*M*N,1]);
market_size = reshape(market_size_wide(:,1:J)',[J*M*N,1]);
portion_size = reshape(portion_size_wide(:,1:J)',[J*M*N,1]);
market_size_bins = reshape(market_size_bins_wide(:,1:J)',[J*M*N,1]);
portion_size_bins = reshape(portion_size_bins_wide(:,1:J)',[J*M*N,1]);
weights = reshape(weights_wide(:,1:J)',[J*M*N,1]);
week_product = findgroups(week,product);
week_firm = findgroups(week,firm);
xi_sum = xi_j+xi_t+xi_s+xi;

% parameters
alpha_wide = exp(repmat(expand(alpha',[N/2,1])-repmat(Sigma(1)*vp_ind(:,2),[2,1]),[M,J+1]));
rho_wide = repmat(rho,[M*N,J+1]);
phi_cal_wide = exp(repmat(expand(phi_cal',[N/2,1])-repmat(Sigma(2)*vp_ind(:,3),[2,1]),[M,J+1]))/100;
phi_sug_wide = exp(repmat(expand(phi_sug',[N/2,1])-repmat(Sigma(3)*vp_ind(:,4),[2,1]),[M,J+1]))/10;
beta0_wide = repmat(expand(beta0',[N/2,1]),[M,J+1]);
beta_fine_wide = zeros(N*M,J+1);
fine_order = [5,2,3,1,4];
for f=1:F
    beta_fine_wide = beta_fine_wide + (fineline_wide==fine_order(f)).*repmat(repmat(Sigma(f+3)*vf_ind(:,f),[2,1]),[M,J+1]);
end

% product level variables
exepmted_prod = extractData(product, exempted);
nu_prod = [extractData(product, nu_cal),extractData(product, nu_sug)];
mu_prod = [extractData(product, mu_cal),extractData(product, mu_sug)];

