
%% FIND MARKET EQUILIBRIUM

function [outcomes] = a03_equilibrium(policy,wbar,tax)

global J M N nu_cal nu_sug p_ori_wide c_wide post_wide exempted_wide mu_cal_wide sigmamu_cal_wide mu_sug_wide sigmamu_sug_wide minerror market_bin nu_prod exepmted_prod ...
    minerror_final maxIter exempted product c Lambda C market_size_bins portion_size_bins week_product week_firm post market alpha Lambda_cal Lambda_sug nut_labeled price_nointervention xi_sum


% INITIALIZE PRICES, NUTRITIONAL CONTENT, EXPECTED W: 
% Note that we work with a wide panel here.
if strcmp(policy,'tax_equilibrium')
    cal = nu_cal - post.*(1-exempted).*(tax(1)./(2*Lambda_cal));
    cal(cal<0) = 0;
    sug = nu_sug - post.*(1-exempted).*(tax(2)./(2*Lambda_sug));
    sug(sug<0) = 0;
else
    cal = nu_cal; 
    sug = nu_sug; 
end
p_wide = p_ori_wide;
pc_wide = p_wide-c_wide;
pc_wide(isnan(pc_wide))=0;
cal_wide = [reshape(cal,[J,N*M])',zeros(N*M,1)];
sug_wide = [reshape(sug,[J,N*M])',zeros(N*M,1)];
l_cal_wide = post_wide.*(cal_wide>wbar(1)).*(1-exempted_wide);
l_sug_wide = post_wide.*(sug_wide>wbar(2)).*(1-exempted_wide);

% beliefs shifters calories
Elab_cal_wide = [sigmamu_cal_wide(:,1:J).*((normpdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))./(1-normcdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))))),zeros(N*M,1)];
Enolab_cal_wide = [-sigmamu_cal_wide(:,1:J).*((normpdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))./(normcdf((wbar(1)-mu_cal_wide(:,1:J))./sigmamu_cal_wide(:,1:J))))),zeros(N*M,1)];
Elab_cal_wide(Elab_cal_wide==Inf|isnan(Elab_cal_wide)) = wbar(1)*ones(length(mu_cal_wide(Elab_cal_wide==Inf|isnan(Elab_cal_wide))),1)-mu_cal_wide(Elab_cal_wide==Inf|isnan(Elab_cal_wide));
Enolab_cal_wide(Enolab_cal_wide==-Inf|isnan(Enolab_cal_wide)) = wbar(1)*ones(length(mu_cal_wide(Enolab_cal_wide==-Inf|isnan(Enolab_cal_wide))),1)-mu_cal_wide(Enolab_cal_wide==-Inf|isnan(Enolab_cal_wide));

% beliefs shifters sugar
Elab_sug_wide = [sigmamu_sug_wide(:,1:J).*((normpdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))./(1-normcdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))))),zeros(N*M,1)];
Enolab_sug_wide = [-sigmamu_sug_wide(:,1:J).*((normpdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))./(normcdf((wbar(2)-mu_sug_wide(:,1:J))./sigmamu_sug_wide(:,1:J))))),zeros(N*M,1)];
Elab_sug_wide(Elab_sug_wide==Inf|isnan(Elab_sug_wide)) = wbar(2)*ones(length(mu_sug_wide(Elab_sug_wide==Inf|isnan(Elab_sug_wide))),1)-mu_sug_wide(Elab_sug_wide==Inf|isnan(Elab_sug_wide));
Enolab_sug_wide(Enolab_sug_wide==-Inf|isnan(Enolab_sug_wide)) = wbar(2)*ones(length(mu_sug_wide(Enolab_sug_wide==-Inf|isnan(Enolab_sug_wide))),1)-mu_sug_wide(Enolab_sug_wide==-Inf|isnan(Enolab_sug_wide));

E_shifter = {Elab_cal_wide,Enolab_cal_wide,Elab_sug_wide,Enolab_sug_wide};

[E_cal_wide,E_sug_wide] = a05_calculateExpectedw(mu_cal_wide,mu_sug_wide,post_wide,l_cal_wide,l_sug_wide,cal_wide,sug_wide,E_shifter,policy);

bunching = zeros(J*M*N,2);
bunching1 = bunching;

if strcmp(policy,'only_demand') || strcmp(policy,'perfect_demand')
    p_wide = [reshape(price_nointervention,[J,N*M])',zeros(M*N,1)];
    [s_wide,~,u,u_true] = a04_calculateShares(p_wide,E_cal_wide,E_sug_wide,cal_wide,sug_wide);
    s = reshape(s_wide(:,1:J)',[J*M*N,1]);
    p = reshape(p_wide(:,1:J)',[J*M*N,1]);
    [CS,CS_bias] = a08_welfare(u,u_true,s_wide);
    outcomes = [s,p,C([cal-nu_cal,sug-nu_sug],c,Lambda),cal,sug,CS,CS_bias];
    disp(' ')
    disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])
    return
end


% INITIALIZE MAIN STATE VARIABLES FOR EQUILIBRIUM
error_b = 10;
error_b_prev = 11;
iter_b = 1;
min_error = minerror;

%%
% LOOP UNTIL WE CONVERGE IN BUNCHING EQ
while(abs(error_b)>minerror && iter_b<maxIter)

if error_b_prev == error_b || iter_b>3
    min_error = minerror_final;
end

% INITIALIZE OTHER STATE VARIABLES FOR EQUILIBRIUM
error = 10*ones(J+1,4);
step_value = ones(J+1,4);
iter = ones(J+1,4);
profits = zeros(M*J*N,4);

% LOOP OVER FIRMS THAT DECIDE WHETHER TO BUNCH
for j=0:J

for b_cal=0:1

skip_cal = 1;  
if j>0
   skip_cal = (nu_prod(j,1)<=wbar(1))||(exepmted_prod(j));
end

if (strcmp(nut_labeled,'sugar') || skip_cal ) && b_cal==1
    profits(:,1+2*b_cal+0) = -Inf*market_size_bins;
    profits(:,1+2*b_cal+1) = -Inf*market_size_bins;
    break
end
    
for b_sug=0:1
    
skip_sug = 1;  
if j>0
   skip_sug = (nu_prod(j,2)<=wbar(2))||(exepmted_prod(j));
end
    
if (strcmp(nut_labeled,'calories') || skip_sug ) && b_sug==1
    profits(:,1+2*0+b_sug) = -Inf*market_size_bins;
    profits(:,1+2*1+b_sug) = -Inf*market_size_bins;
    break
end

% disp('finding equilibrium...')
% LOOP UNTIL FINDING FIXED POINT 
while(abs(error(j+1,1+2*b_cal+b_sug))>min_error && iter(j+1,1+2*b_cal+b_sug)<maxIter)   

% We calculate utility of consuming each product given P, W, and E:
[s_wide,s_g_wide,~,~] = a04_calculateShares(p_wide,E_cal_wide,E_sug_wide,cal_wide,sug_wide);

% We reshape the data to work with a long panel.
s = reshape(s_wide(:,1:J)',[J*M*N,1]);
p = reshape(p_wide(:,1:J)',[J*M*N,1]);
cal = reshape(cal_wide(:,1:J)',[J*M*N,1]);
sug = reshape(sug_wide(:,1:J)',[J*M*N,1]);

% With the firm FOC we find P and W. 
[markup] = a06_calculateMarkup(s_wide,s_g_wide,pc_wide);
if strcmp(policy,'perfect_equilibrium')
    [mark_cal,mark_sug] = a07_calculateReformulation(s_wide,s_g_wide);
    if strcmp(nut_labeled,'calories')
    cal1 = nu_cal - post.*(mark_cal./(2*Lambda_cal));
    cal1(cal1<0) = 0;
    sug1 = nu_sug;
    elseif strcmp(nut_labeled,'sugar')
    sug1 = nu_sug - post.*(mark_sug./(2*Lambda_sug));
    sug1(sug1<0) = 0;
    cal1 = nu_cal;
    elseif strcmp(nut_labeled,'both')
    sug1 = nu_sug - post.*(mark_sug./(2*Lambda_sug));
    cal1 = nu_cal - post.*(mark_cal./(2*Lambda_cal));
    sug1(sug1<0) = 0;
    cal1(cal1<0) = 0;
    end
    cal1p = cal1;
    sug1p = sug1;
    cal1 = (cal1+29*cal)/30;
    sug1 = (sug1+29*sug)/30;
elseif strcmp(policy,'tax_equilibrium')
    cal1 = nu_cal - post.*(1-exempted).*(tax(1)./(2*Lambda_cal));
    cal1(cal1<0) = 0;
    sug1 = nu_sug - post.*(1-exempted).*(tax(2)./(2*Lambda_sug));
    sug1(sug1<0) = 0;
else
    cal1 = nu_cal;
    sug1 = nu_sug;
end

% Other firms that are already bunching
cal1((bunching(:,1)==1)&(exempted==0)&(product~=j)) = wbar(1);
sug1((bunching(:,2)==1)&(exempted==0)&(product~=j)) = wbar(2);

% Firm j decides to bunch
if b_cal==1
    cal1((post==1)&(product==j & nu_cal>wbar(1))&(exempted==0)) = wbar(1);
end
if b_sug==1
    sug1((post==1)&(product==j & nu_sug>wbar(2))&(exempted==0)) = wbar(2);
end
if ~strcmp(policy,'perfect_equilibrium')
    cal1p = cal1;
    sug1p = sug1;
end
c1 = C([cal1-nu_cal,sug1-nu_sug],c,Lambda);
p1 = ( c1 + markup + tax(1)*post.*(1-exempted).*cal1 + tax(2)*post.*(1-exempted).*sug1);
p1(p1>10 & p1<Inf) = 10;
prof = (p1-C([cal1-nu_cal,sug1-nu_sug],c,Lambda)- tax(1)*post.*(1-exempted).*cal1 - tax(2)*post.*(1-exempted).*sug1).*s.*market_size_bins.*portion_size_bins;
p1p = p1;

% Smoothing price converge
if step_value(j+1,1+2*b_cal+b_sug) <= 1 && iter(j+1,1+2*b_cal+b_sug) < 20
    
elseif step_value(j+1,1+2*b_cal+b_sug) <= 2 && iter(j+1,1+2*b_cal+b_sug) < 40
    p1 = (p1+1*p)/2;
elseif step_value(j+1,1+2*b_cal+b_sug) <= 3 && iter(j+1,1+2*b_cal+b_sug) < 80
    p1 = (p1+4*p)/5;
elseif step_value(j+1,1+2*b_cal+b_sug) <= 4 && iter(j+1,1+2*b_cal+b_sug) < 150
    p1 = (p1+9*p)/10;
elseif step_value(j+1,1+2*b_cal+b_sug) <= 5 && iter(j+1,1+2*b_cal+b_sug) < 400
    p1 = (p1+29*p)/30;
elseif step_value(j+1,1+2*b_cal+b_sug) <= 6 && iter(j+1,1+2*b_cal+b_sug) < 1000
    p1 = (p1+49*p)/50;
else
    p1 = (p1+99*p)/100;
end

% update beliefs and return variables to wide
cal_wide = [reshape(cal1,[J,M*N])',zeros(M*N,1)];
sug_wide = [reshape(sug1,[J,M*N])',zeros(M*N,1)];
l_cal_wide = post_wide.*(cal_wide>wbar(1)).*(1-exempted_wide);
l_sug_wide = post_wide.*(sug_wide>wbar(2)).*(1-exempted_wide);
[E_cal_wide,E_sug_wide] = a05_calculateExpectedw(mu_cal_wide,mu_sug_wide,post_wide,l_cal_wide,l_sug_wide,cal_wide,sug_wide,E_shifter,policy);

% We iterate until p converges
pre_error = error(j+1,1+2*b_cal+b_sug);
if strcmp(policy,'perfect_equilibrium') || iter(j+1,1+2*b_cal+b_sug)==1
    error(j+1,1+2*b_cal+b_sug) = (p(p<Inf)-p1p(p1p<Inf))'*(p(p<Inf)-p1p(p1p<Inf)) + (cal(p<Inf)-cal1p(p1p<Inf))'*(cal(p<Inf)-cal1p(p1p<Inf)) + (sug(p<Inf)-sug1p(p1p<Inf))'*(sug(p<Inf)-sug1p(p1p<Inf));
else
    error(j+1,1+2*b_cal+b_sug) = (p(p<Inf)-p1p(p1p<Inf))'*(p(p<Inf)-p1p(p1p<Inf));
end
if pre_error < error(j+1,1+2*b_cal+b_sug) && iter(j+1,1+2*b_cal+b_sug)>1 
    step_value(j+1,1+2*b_cal+b_sug) = step_value(j+1,1+2*b_cal+b_sug)+1;
end

p = p1;
p_wide = [reshape(p,[J,M*N])',zeros(M*N,1)];
c1_wide = [reshape(c1,[J,N*M])',zeros(N*M,1)];
tax_wide = [reshape(tax(1)*post.*(1-exempted).*cal1 + tax(2)*post.*(1-exempted).*sug1,[J,N*M])',zeros(N*M,1)];
pc_wide = p_wide-c1_wide-tax_wide;
pc_wide(isnan(pc_wide))=0;
profits(:,1+2*b_cal+b_sug) = prof;

iter(j+1,1+2*b_cal+b_sug) = iter(j+1,1+2*b_cal+b_sug)+1;

end

  
end
end


% ALLOW FIRMS TO BUNCH IF BETTER OFF
if j>0

prof_j = zeros(M*J*N,4);
temp  = accumarray( week_firm(p<Inf), product(p<Inf)==j ) ;
num_j = temp(week_firm);
for i=1:4
    temp  = accumarray( week_firm(p<Inf), profits(p<Inf,i) ) ;
    temp = temp(week_firm);
    prof_j(:,i) = temp.*(product==j);
end
[~,index] = max(prof_j,[],2);
index = index.*(product==j).*(num_j>0);

bunching((index==1 | index==2),1) = 0; 
bunching((index==1 | index==3),2) = 0; 
bunching((post==1)&(cal1==wbar(1))&(cal1~=nu_cal)&(index==3 | index==4),1) = 1; 
bunching((post==1)&(sug1==wbar(2))&(sug1~=nu_sug)&(index==2 | index==4),2) = 1; 

% SET NEW NUTRITIONAL CONTENT LEVELS AND BELIEFS
if strcmp(policy,'perfect_equilibrium')
    [mark_cal,mark_sug] = a07_calculateReformulation(s_wide,s_g_wide);
    if strcmp(nut_labeled,'calories')
    cal = nu_cal - post.*(mark_cal./(2*Lambda_cal));
    cal(cal<0) = 0;
    sug = nu_sug;
    elseif strcmp(nut_labeled,'sugar')
    sug = nu_sug - post.*(mark_sug./(2*Lambda_sug));
    sug(sug<0) = 0;
    cal = nu_cal;
    elseif strcmp(nut_labeled,'both')
    sug = nu_sug - post.*(mark_sug./(2*Lambda_sug));
    cal = nu_cal - post.*(mark_cal./(2*Lambda_cal));
    sug(sug<0) = 0;
    cal(cal<0) = 0;
    end
elseif strcmp(policy,'tax_equilibrium')
    cal = nu_cal - post.*(1-exempted).*(tax(1)./(2*Lambda_cal));
    cal(cal<0) = 0;
    sug = nu_sug - post.*(1-exempted).*(tax(2)./(2*Lambda_sug));
    sug(sug<0) = 0;
else
    cal = nu_cal;
    sug = nu_sug;
end
cal((bunching(:,1)==1)&(exempted==0)) = wbar(1);
sug((bunching(:,2)==1)&(exempted==0)) = wbar(2);
cal_wide = [reshape(cal,[J,M*N])',zeros(M*N,1)];
sug_wide = [reshape(sug,[J,M*N])',zeros(M*N,1)];
l_cal_wide = post_wide.*(cal_wide>wbar(1)).*(1-exempted_wide);
l_sug_wide = post_wide.*(sug_wide>wbar(2)).*(1-exempted_wide);
[E_cal_wide,E_sug_wide] = a05_calculateExpectedw(mu_cal_wide,mu_sug_wide,post_wide,l_cal_wide,l_sug_wide,cal_wide,sug_wide,E_shifter,policy);


if strcmp(policy,'only_demand') || strcmp(policy,'no_bunching') || strcmp(policy,'no') || strcmp(policy,'perfect_equilibrium') || strcmp(policy,'perfect_demand') || strcmp(policy,'perfect_no_bunching') || strcmp(policy,'tax_equilibrium') || strcmp(policy,'tax_demand')
    break
end

end

if strcmp(policy,'only_demand') || strcmp(policy,'no_bunching') || strcmp(policy,'no') || strcmp(policy,'perfect_equilibrium') || strcmp(policy,'perfect_demand') || strcmp(policy,'perfect_no_bunching') || strcmp(policy,'tax_equilibrium') || strcmp(policy,'tax_demand')
    break
end



end

error_b_prev = error_b;
error_b = (bunching(:,1)-bunching1(:,1))'*(bunching(:,1)-bunching1(:,1))+(bunching(:,2)-bunching1(:,2))'*(bunching(:,2)-bunching1(:,2));

disp(' ')
disp(['results from iter ',int2str(iter_b),' : ', int2str(error_b)])
disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])

bunching1 = bunching;
iter_b = iter_b+1;

if error_b == error_b_prev && error_b<=12800
    break
end

end

%%


disp(' ')
disp('Finding final equilibrium..')

% INITIALIZE STATE VARIABLES FOR FINAL EQUILIBRIUM
error = 10;
step_value = 1;
iter = 1;



cal_wide = [reshape(nu_cal,[J,M*N])',zeros(M*N,1)];
sug_wide = [reshape(nu_sug,[J,M*N])',zeros(M*N,1)];
l_cal_wide = post_wide.*(cal_wide>wbar(1)).*(1-exempted_wide);
l_sug_wide = post_wide.*(sug_wide>wbar(2)).*(1-exempted_wide);
[E_cal_wide,E_sug_wide] = a05_calculateExpectedw(mu_cal_wide,mu_sug_wide,post_wide,l_cal_wide,l_sug_wide,cal_wide,sug_wide,E_shifter,policy);
p_wide = p_ori_wide;
pc_wide = p_wide-c_wide;
pc_wide(isnan(pc_wide))=0;

while(abs(error)>minerror_final && iter<maxIter)

% We calculate utility of consuming each product given P, W, and E:
[s_wide,s_g_wide,~,~] = a04_calculateShares(p_wide,E_cal_wide,E_sug_wide,cal_wide,sug_wide);

% We reshape the data to work with a long panel.
s = reshape(s_wide(:,1:J)',[J*M*N,1]);
p = reshape(p_wide(:,1:J)',[J*M*N,1]);

% With the firm FOC we find P and W. 
[markup] = a06_calculateMarkup(s_wide,s_g_wide,pc_wide);
if strcmp(policy,'perfect_equilibrium')
    [mark_cal,mark_sug] = a07_calculateReformulation(s_wide,s_g_wide);
    if strcmp(nut_labeled,'calories')
    cal1 = nu_cal - post.*(mark_cal./(2*Lambda_cal));
    cal1(cal1<0) = 0;
    sug1 = nu_sug;
    elseif strcmp(nut_labeled,'sugar')
    sug1 = nu_sug - post.*(mark_sug./(2*Lambda_sug));
    sug1(sug1<0) = 0;
    cal1 = nu_cal;
    elseif strcmp(nut_labeled,'both')
    sug1 = nu_sug - post.*(mark_sug./(2*Lambda_sug));
    cal1 = nu_cal - post.*(mark_cal./(2*Lambda_cal));
    sug1(sug1<0) = 0;
    cal1(cal1<0) = 0;
    end
    cal1p = cal1;
    sug1p = sug1;
    cal1 = (cal1+29*cal)/30;
    sug1 = (sug1+29*sug)/30;
elseif strcmp(policy,'tax_equilibrium') || strcmp(policy,'equilibrium')
    cal1 = nu_cal - post.*(1-exempted).*(tax(1)./(2*Lambda_cal));
    cal1(cal<0) = 0;
    sug1 = nu_sug - post.*(1-exempted).*(tax(2)./(2*Lambda_sug));
    sug1(sug1<0) = 0;
else
    cal1 = nu_cal;
    sug1 = nu_sug;
end

cal1((bunching(:,1)==1)&(exempted==0)) = wbar(1);
sug1((bunching(:,2)==1)&(exempted==0)) = wbar(2);
if ~strcmp(policy,'perfect_equilibrium')
    cal1p = cal1;
    sug1p = sug1;
end
c1 = C([cal1-nu_cal,sug1-nu_sug],c,Lambda);
p1 = ( c1 + markup + tax(1)*post.*(1-exempted).*cal1 + tax(2)*post.*(1-exempted).*sug1);
p1p = p1;

% Smoothing price converge
if step_value <= 1 && iter < 20 
    
elseif step_value <= 2 && iter < 40 
    p1 = (p1+1*p)/2;
elseif step_value <= 3 && iter < 80 
    p1 = (p1+4*p)/5;
elseif step_value <= 4 && iter < 150 
    p1 = (p1+9*p)/10;
elseif step_value <= 5 && iter < 400 
    p1 = (p1+29*p)/30;
elseif step_value <= 6 && iter < 1000 
    p1 = (p1+49*p)/50;
else
    p1 = (p1+99*p)/100;
end

% update beliefs and return variables to wide
cal_wide = [reshape(cal1,[J,M*N])',zeros(M*N,1)];
sug_wide = [reshape(sug1,[J,M*N])',zeros(M*N,1)];
l_cal_wide = post_wide.*(cal_wide>wbar(1)).*(1-exempted_wide);
l_sug_wide = post_wide.*(sug_wide>wbar(2)).*(1-exempted_wide);
[E_cal_wide,E_sug_wide] = a05_calculateExpectedw(mu_cal_wide,mu_sug_wide,post_wide,l_cal_wide,l_sug_wide,cal_wide,sug_wide,E_shifter,policy);

% We iterate until p converges
pre_error = error;
if strcmp(policy,'perfect_equilibrium')
    error = (p(p<Inf)-p1p(p1p<Inf))'*(p(p<Inf)-p1p(p1p<Inf)) + (cal(p<Inf)-cal1p(p1p<Inf))'*(cal(p<Inf)-cal1p(p1p<Inf)) + (sug(p<Inf)-sug1p(p1p<Inf))'*(sug(p<Inf)-sug1p(p1p<Inf));
else
    error = (p(p<Inf)-p1p(p1p<Inf))'*(p(p<Inf)-p1p(p1p<Inf));
end
    
if pre_error < error && iter>1 
    step_value = step_value+1;
end

p = p1;
cal = cal1;
sug = sug1;
p_wide = [reshape(p,[J,M*N])',zeros(M*N,1)];
c1_wide = [reshape(c1,[J,N*M])',zeros(N*M,1)];
tax_wide = [reshape(tax(1)*post.*(1-exempted).*cal1 + tax(2)*post.*(1-exempted).*sug1,[J,N*M])',zeros(N*M,1)];
pc_wide = p_wide-c1_wide-tax_wide;
pc_wide(isnan(pc_wide))=0;
iter = iter+1;

end 

if strcmp(policy,'no')
    maxIter = iter;
end

[E_cal_wide,E_sug_wide] = a05_calculateExpectedw(mu_cal_wide,mu_sug_wide,post_wide,l_cal_wide,l_sug_wide,cal_wide,sug_wide,E_shifter,policy);

[~,~,u,u_true] = a04_calculateShares(p_wide,E_cal_wide,E_sug_wide,cal_wide,sug_wide);

[CS,CS_bias] = a08_welfare(u,u_true,s_wide);
    
outcomes = [s,p,C([cal-nu_cal,sug-nu_sug],c,Lambda),cal,sug,CS,CS_bias];


disp(['Elapsed time is: ',num2str(toc/60),' minutes.'])

end



