

function [s_wide,s_g_wide,u,u_true] = a04_calculateShares(p_wide,E_cal_wide,E_sug_wide,cal_wide,sug_wide)

global M J N beta0_wide alpha_wide phi_cal_wide phi_sug_wide beta_fine_wide rho xi_j_wide xi_t_wide xi_s_wide xi_wide 

% We calculate utility of consuming each product given P, W, and E:
u = beta0_wide.*[ones(M*N,J),zeros(M*N,1)] -alpha_wide.*p_wide - phi_cal_wide.*E_cal_wide - phi_sug_wide.*E_sug_wide + beta_fine_wide + xi_j_wide + xi_t_wide + xi_s_wide + xi_wide;
u_true = beta0_wide.*[ones(M*N,J),zeros(M*N,1)] -alpha_wide.*p_wide - phi_cal_wide.*cal_wide - phi_sug_wide.*sug_wide + beta_fine_wide + xi_j_wide + xi_t_wide + xi_s_wide + xi_wide;

% We calculate the market shares using the logit formula
temp = (sum(exp(u(:,1:J)./(1-rho)),2));
sum_D = 1+temp.^(1-rho);
D_nests = [repmat(temp.^rho,[1,J]),ones(M*N,1)];
s_wide = exp(u./(1-rho))./((D_nests).*sum_D);
s_g_wide = [s_wide(:,1:J)./sum(s_wide(:,1:J),2),ones(M*N,1)];




end



