

function [markup,zeta] = a06_calculateMarkup(s_wide,s_g_wide,pc_wide)

global alpha_wide J rho_wide firm_wide M market_wide N  weights_wide

weighted_shares = s_wide.*weights_wide;
s_m_wide = cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),weighted_shares(:,x)),1:J+1,'un',0));
if nargin > 2
    weighted_pc = pc_wide.*weights_wide;
    pc_m_wide = cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),weighted_pc(:,x)),1:J+1,'un',0));
end

markup = zeros(J*N*M,1);
zeta = zeros(J*N*M,1);
e_JJ = eye(J);
same_firm = (firm_wide(1,1:J)==firm_wide(1,1:J)');
ds_j = (alpha_wide(:,1:J).*weights_wide(:,1:J).*s_wide(:,1:J)./(1-rho_wide(:,1:J)))';
ds_k = (rho_wide(:,1:J).*s_g_wide(:,1:J) + (1-rho_wide(:,1:J)).*s_wide(:,1:J));
market_choice = market_wide(:,1);

for m=1:M

ds_dp_m = ((ds_j(:,market_choice==m)*ds_k((market_choice==m),:).*(1-e_JJ)) + -(ds_j(:,market_choice==m)*(1-ds_k((market_choice==m),:)).*e_JJ));

if nargin > 2
    Lambda = -diag(sum(ds_j(:,market_choice==m),2));
    Gamma = -ds_dp_m+Lambda;
end

if nargin == 2
    
    tmp = ds_dp_m(1:J+1:end);
    tmp(tmp==0)=99;
    ds_dp_m(1:J+1:end) = tmp;

    Delta_m = sparse(ds_dp_m.*same_firm);

    mkup = -Delta_m\s_m_wide(m,1:J)';
    markup((J*N*(m-1)+1):(J*N*m)) = repmat(mkup,[N,1]);

elseif nargin > 2

    tmp = Lambda(1:J+1:end);
    tmp(tmp==0)=99;
    Lambda(1:J+1:end) = tmp;

    Gamma_m = Gamma.*same_firm;

    zta = Lambda\Gamma_m'*pc_m_wide(m,1:J)'-Lambda\s_m_wide(m,1:J)';
    zeta((J*N*(m-1)+1):(J*N*m)) = repmat(zta,[N,1]);
        
end

end

if nargin > 2
    markup = zeta;
end





    

