

function [mark_cal,mark_sug] = a07_calculateReformulation(s_wide,s_g_wide)

global J firm_wide M N market_wide alpha_wide rho_wide phi_cal_wide phi_sug_wide weights_wide

weighted_shares = s_wide.*weights_wide;
s_m_wide = cell2mat(arrayfun(@(x) accumarray(market_wide(:,1),weighted_shares(:,x)),1:J+1,'un',0));  

mark_cal = zeros(J*N*M,1);
mark_sug = zeros(J*N*M,1);
e_JJ = eye(J);
same_firm = (firm_wide(1,1:J)==firm_wide(1,1:J)');
ds_j = (alpha_wide(:,1:J).*weights_wide(:,1:J).*s_wide(:,1:J)./(1-rho_wide(:,1:J)))';
ds_k = (rho_wide(:,1:J).*s_g_wide(:,1:J) + (1-rho_wide(:,1:J)).*s_wide(:,1:J));
dsug_j = (phi_sug_wide(:,1:J).*weights_wide(:,1:J).*s_wide(:,1:J)./(1-rho_wide(:,1:J)))';
dcal_j = (phi_cal_wide(:,1:J).*weights_wide(:,1:J).*s_wide(:,1:J)./(1-rho_wide(:,1:J)))';
market_choice = market_wide(:,1);

for m=1:M

ds_dp_m = ((ds_j(:,market_choice==m)*ds_k((market_choice==m),:).*(1-e_JJ)) + -(ds_j(:,market_choice==m)*(1-ds_k((market_choice==m),:)).*e_JJ));
ds_dsug_m = ((dsug_j(:,market_choice==m)*ds_k((market_choice==m),:).*(1-e_JJ)) + -(dsug_j(:,market_choice==m)*(1-ds_k((market_choice==m),:)).*e_JJ));
ds_dcal_m = ((dcal_j(:,market_choice==m)*ds_k((market_choice==m),:).*(1-e_JJ)) + -(dcal_j(:,market_choice==m)*(1-ds_k((market_choice==m),:)).*e_JJ));

tmp = ds_dp_m(1:J+1:end);
tmp(tmp==0)=99;
ds_dp_m(1:J+1:end) = tmp;

tmp = ds_dsug_m(1:J+1:end);
tmp(tmp==0)=99;
ds_dsug_m(1:J+1:end) = tmp;

tmp = ds_dcal_m(1:J+1:end);
tmp(tmp==0)=99;
ds_dcal_m(1:J+1:end) = tmp;

Delta_m = sparse(ds_dp_m.*same_firm);
Square_m_sug = sparse(ds_dsug_m.*same_firm);
Square_m_cal = sparse(ds_dcal_m.*same_firm);

markup = Delta_m\s_m_wide(m,1:J)';

mark_cal((J*N*(m-1)+1):(J*N*m)) = repmat((Square_m_cal*markup)./s_m_wide(m,1:J)',[N,1]);
mark_sug((J*N*(m-1)+1):(J*N*m)) = repmat((Square_m_sug*markup)./s_m_wide(m,1:J)',[N,1]);

end

mark_cal(isnan(mark_cal)) = 0;
mark_sug(isnan(mark_sug)) = 0;


end





    

